19990814-19:50 GMT+1 Victor Szel <info@szelvesz.hu>
  * source/compiler/harbour.y
    ! BYTE -> unsigned char
    Previous change reverted, and replaced with a NOTE: not to
    change this again.

19990814-19:30 GMT+1 Victor Szel <info@szelvesz.hu>
  * source/vm/dynsym.c
    tests/working/dynsym.prg
    * Name change to allow these functions to work even in 10 character
      symbol limit mode.
      __DYNSYMCOUNT    -> __DYNSCOUNT
      __DYNSYMGETNAME  -> __DYNSGETNAME
      __DYNSYMGETINDEX -> __DYNSGETINDEX
  * make_tpl.*
    + PRG_USR added.
  * source/runner/runner.c
    ! Fixed warning with unused InitSymbolTable() function.
  * source/rtl/dates.c
    * hb__seconds() -> hb_seconds()
  * tests/working/fortest.prg
    tests/working/Makefile
    + New test file added. (It's broken BTW)
  * source/compiler/harbour.y
    * unsigned char -> BYTE
  * source/rtl/console.c
    * unsigned short -> USHORT
  * source/rtl/transfrm.c
    * unsigned long -> ULONG/DWORD
  * source/rtl/classes.c
    ! Added two missing prototypes.

19990813-16:47 GMT+3 Alexander Kresin
  * source/rtl/tbrowse.prg
  * tests/working/testbrw.prg
    * added some functionality ( PageDown(), PageUp(), GoBottom(), GoTop() )

19990813-11:00 GMT+2 Ryszard Glab <rglab@imid.med.pl>

    *source/compiler/harbour.y
        *corrected generation of local variables positions when
         PARAMETERS are used (for example: if there are
         two declared PARAMETERS, then the first local variable
         are placed on third position)

19990813-01:30 EDT David G. Holm <dholm@jsd-llc.com>
  * config/os2/gcc.cf
    - Removed -( and -), which OS/2 GCC does not support.
  * config/os2/icc.cf
    + Added handling of HB_DB_DRIVERS.
  * include/hbsetup.h
    + If HARBOUR_GCC_OS2 is defined, then OS2 must get defined.
  * include/hbver.h
    * Set hb_revision to "a", hb_month to 8, and hb_day to 12.
  * source/compiler/harbour.y
    + Display revision code immediately following build code
      (e.g., "Build 29a (1999.08.12)"
    ! Moved display of compiler version from inside Include()
      to immediately following command line option processing,
      so that the version will always be displayed, unless the
      /q option or an unsupported output language option is used.
  * source/debug/debugger.prg
    ! Changed CLEAR TO on line 208 to SCROLL(), to work around
      preprocessor problem with certain compilers.
  * source/rtl/console.c
    ! Corrected display erasing for BackSpace in HB___ACCEPT()
      for Harbour builds that are using the GT API.
  * source/rtl/tone.c
    ! Don't include <pc.h> for Borland C.
    + Added support for OS/2 GCC/EMX.
  * source/rtl/gt/gtos2.c
    ! Put the fixes for the x vs. y coordinates bugaboo and the
      change from DWORD to ULONG back in.
  * tests/working/Makefile
    ! Added rtl to the library list so that it can include rdd
      functions and the rdd can include rtl functions for those
      compilers that have no way to force recursive checking of
      libraries (specifically, OS/2 GCC 2.8.1).

19990812-22:29 GMT+3 Alexander Kresin
  * source/rtl/tbrowse.prg
  * source/rtl/tbcolumn.prg
  * tests/working/testbrw.prg
    * added some functionality
  * funclist.txt
    * updated status of TBrowse functions

19990812-14:15 EDT David G. Holm <dholm@jsd-llc.com>
  * funclist.txt
    * Updated the status of several functions to S or R
    * Updated the status of the errornew class and its members to R

19990812-14:00 EDT David G. Holm <dholm@jsd-llc.com>
  * source/rtl/Makefile
    + Added tone.c
  + source/rtl/tone.c
    + New TONE() function supplied by Chen Kedem <niki@synel.co.il>
      I reorganized it so that Harbour C functions can generate tones
      by callin hb_tone( <dFrequncy>, <dDuration> ) and I also added
      DOS support for Borland and DJGPP.
  * tests/working/Makefile
    + Added sound.prg
  + tests/working/sound.prg
    + New test module to test TONE() function.

19990812-14:10 GMT+2 Ryszard Glab <rglab@imid.med.pl>

    *source/compiler/harbour.y
        * PARAMETERS statement can be used before LOCAL statement
         (the stack frame is calculated correctly)
        * PARAMETERS statement cannot be used if there are local
         parameters (parameters inside '()') declared already

    *include/compiler.h
        + added wParamNum member to _FUNC structure

    *include/hberrors.h
        + added new error code ERR_PARAMETERS_NOT_ALLOWED

    *source/rtl/console.c
        * corrected `\0` to '\x0' for OS_UNIX_COMPATIBLE

19990812-08:32 GMT+1 Antonio Linares <alinares@fivetech.com>
  * source/rtl/tbrowse.prg
    * enhanced

19990812-01:45 EDT Paul Tucker <ptucker@sympatico.ca>
  * source/rtl/gt/gtwin.c
    * corrections to window sizing between dispbegin buffers - this part
      is now working as it should.  There is still the problem of
      writing past the visible screen boundry which will gpf.
  * source/rtl/gtapi.c
    * temporarily limit string length in hb_gtwrite (attempting to avoid
      above problem)

19990811-09:01 GMT+3 Alexander Kresin
  * source/hbpp/hbpp.c
    * fixed some bugs
    *changed logic of #translates scan, so it is possible now use
     #translate with non alphabetical definitions ( such as '::', for
     example ).

19990811-18:00 EDT Paul Tucker <ptucker@sympatico.ca>
  * source/rtl/gt/gtwin.c
    * hb_gt_getRow/Col were using the wrong screen handle.

19990811-14:30 EDT Paul Tucker <ptucker@sympatico.ca>
  * source/rtl/console.c
    * set binary mode on stanard files before intializing gt system.
    * HB_SCROLL - changed to only call hb_max_row and col once each.
  * source/rtl/gtapi.c
    * hb_gtInit()
      + add call to hb_gtMaxRow and Col to initialize statics properly
      - remove calls to setmode, setpos and setcursor
    * some reformatting
  * source/rtl/gt/gtwin.c
    * simplified hb_gtDone
    * modified code that returns maxrow and col to take into account
      a window that is larger than the display region.  Now the system
      will use a screen size of 25x40 or the visible window, whichever
      is greater.  Comments?
      NOTE: if you resize the window after initialization, Dispbegin/end
      may cause the screen to jump around a bit - this will be corrected.
      Also, if you resize the window while a savescreen is in effect,
      the resulting restore screen will be unpleasant -this is being
      reviewed.
    * simplified hb_gt_DrawShadow
    + static hb_gt_SetScreenBuffer()
      * dispbegin/end support routine
    ! changed hb_gt_SetMode to return BOOL
  * include/gtapi.h source/rtl/gtdos.c
    ! changed hb_gt_SetMode to return BOOL
  * source/rtl/gtos2.c (Chen Kedem <niki@actcom.co.il>)
    ! changed hb_gt_SetMode to return BOOL
    + hb_gt_IsColor()
    + hb_gt_SetAttribute()
    + hb_gt_DrawShadow()
  * source/rt/gt/gt_tpl.c
    * changed a comment

19990811-11:35 EDT David G. Holm <dholm@jsd-llc.com>
  * doc/gmake.txt
    + Added a new section under 'NOTES' discussing how to build only
      parts of Harbour, with examples for Harbour only and tests only
      and how to build a single test file using the DOS build.bat file.
  * source/rtl/console.c
    ! Corrected #ifdef blocks for unistd.h and io.h.
    ! Added code to remove newline in Unix compatible ACCEPT() code,
      per Georg Lehner <jorge_lehner@gmx.net>.
  * source/rtl/setkey.prg
    * New version from April White <awhite@user.rose.com>.
  * source/rtl/gt/gtdos.c
    + Added DJGPP compatible GTAPI handling, but not sure how to deal
      with dispbegin()/dispend(). Need to add cursor handling.
  * source/rtl/gt/gtos2.c
    ! Changed DWORD to ULONG.
  * tests/working/Makefile
    ! Added new setkey test program (as BAD, because no GETACTIVE()).
  + tests/working/setkey.prg
    + New test program from April White <awhite@user.rose.com>.
      Note: Needs a working get system and needs SetKeyCheck()
      integrated into the appropriate Harbour input functions.

19990810-00:55 EDT Paul Tucker <ptucker@sympatico.ca>
  * source/rtl/gtapi.c source/rtl/gt/gtwin/c source/rtl/gt/gt_tpl.c
    * minor formatting changes
    * corrected an instance of nested comments.

19990809-14:15 EDT Paul Tucker <ptucker@sympatico.ca>
  + source/rtl/xsavescr.prg
    * support for save screen and restore screen commands.
    + __xSaveScreen() and __xRestScreen()
  * source/rtl/Makefile
    + xsavescr.prg
  * makefile.vc
    + xsavescr.prg

19990809-13:10 EDT Paul Tucker <ptucker@sympatico.ca>
  * source/rtl/gt_tpl.c
    + added a number of TODO comments
  * from  Chen Kedem <niki@actcom.co.il>
  * source/rtl/gt/gtos2.c
    + support for:
      hb_gt_Get/SetBlink
      hb_gt_Get/SetCursorStyle

Mon Aug 09 11:53:18 1999  Gonzalo A. Diethelm  <Gonzalo.Diethelm@jda.cl>

        * source/Makefile:
        Moved the debug directory after rdd.

        * source/hbpp/hbpp.c:
        * source/rtl/filesys.c:
        * source/runner/runner.c:
        Got rid of several warnings.

199908.09-15:24 GMT+3 Alexander Kresin
  * source/hbpp/hbpp.c
    * fixed problem with new DATA implementation

19990809-12:20 GMT+2 Ryszard Glab <rglab@imid.med.pl>

    *source/compiler/harbour.y
        * restored all code related to debugger
        * fixed alias expressions in '=' statement

199908.09-13:12 GMT+3 Alexander Kresin
  * source/hbpp/hbpp.c
    * added support for list match patterns

19990809-03:47 EDT Paul Tucker <ptucker@sympatico.ca>
   * source/compiler/harbour.l
     + added DECLARE statement - treated as PRIVATE
       (Don't recall the exact rules for DECLARE)

19990809-03:23 EDT Paul Tucker <ptucker@sympatico.ca>
   * source/rtl/filesys.c"source/rtl/filesys"
     * hb_fsLock implimented for msvc

19990809-07:40 GMT+1 Victor Szel <info@szelvesz.hu>
   * source/odbc moved to contrib/odbc
   * source/rtl/console.c
     + #include "io.h" added for __CYGWIN__
   * tests/working/block2.PRG removed.
   * tests/working/transdef.prg
     tests/working/testrdd.prg
     tests/working/testpre.prg
     tests/working/testdbf.prg
     tests/working/strsub.prg
     tests/working/dates4.prg
     ! CVS tag added.
   * source/rtl/mtran.c
     ! Small typo.

19990809-06:23 GMT+1 Victor Szel <info@szelvesz.hu>
   * include/memvars.ch
     ! #ifdef _MEMVARS_CH guard added.
     ! Changed all comments to ANSI C style, since it's included in C code, too.
   * source/rtl/errorapi.c
     + Fixed logic for _errLaunch(), it seem ready now, plus highly
       Clipper compatible.
   * source/Makefile
     + runner added.
   * source/odbc/odbc.c
     ! Small typo fixed.
   * source/rtl/menuto.prg
     + Handles non-declared variables correctly. Uses __MVSCOPE().
   * include/hbdefs.h
     * Small cleanup, typo fix.
   * tests/working/copyfile.prg
     tests/working/copyfile.txt (removed)
     % copyfile.txt is no longer needed.
     * Open error test uses a much more rare file name.

19990808-20:55 GMT+2 Ryszard Glab <rglab@imid.med.pl>

    *source/compiler/harbour.y
        * corrected checking for duplicated variable names when
         MEMVAR and PRIVATE variable was declared
        * Arguments used in DO ... WITH ... are pushed correctly now
         using either a value or a reference
        * RETURN statement is no longer generating JMP opcodes - it generates
         HB_P_ENDPROC opcode now
        * generated C code again includes "init.h"
        + added support for aliased expressions (it seems that generated
         C code is correct)

    *source/rtl/do.c
        + added documentation

    *source/rtl/memvars.c
        + added __MVSCOPE function to check if variable is created already

    *include/memvars.ch
        ! new file that defines the values returned from __MVSCOPE
         function

    *include/hb_vmpub.h
    *include/extend.h
        * changed to not duplicate definition of structures and type.
         Duplicated definitions have caused undefined symbols during
         linking of C++ compiler (Watcom) output. The C++ compilers
         can mangle function's name into different names when
         duplicated definitions of data types are used.

    *source/rtl/initsymb.c
        + added again '#include "init.h"' - because some definitions
         were moved into hb_vmpub.h to avoid problems with duplicated
         definitions of data types.

    *include/langapi.h
        - removed declaration of extern langDef (Watcom reported error)
         see TODO comment in this file

    *include/pcode.h
        - removed unused HB_P_PUSHWORD
        + added opcodes:
                HB_P_POPALIAS
                HB_P_PUSHALIAS
                HB_P_SWAPALIAS
                HB_P_POPFIELD
                HB_P_PUSHFIELD
                HB_P_POPALIASEDFIELD
                HB_P_PUSHALIASEDFIELD
        NOTE:
        You have to rebuild all harbour libraries and object files !

    *source/vm/hvm.c
        + added initial support for aliased expressions (fields are not
         handled yet - we need to synchronize it with RDD development)

    *include/hberrors.h
        + added ERR_INVALID_REFER reported when field or aliased variable
         is passed by the reference

    *tests/working/alias.prg
        + new file to check if aliased expressions are handled correctly
         (only manual check at this moment - by looking at generated
         C code)

    *test/working/Makefile
        + added alias.prg into BAD_PRG_SOURCES because it cannot be run yet
        - removed debugger.prg

    *source/rtl/console.c
        - io.h cannot be included on Linux/GCC (placed inside #ifdef)

    *source/vm/dynsym.c
        + restored definition of SYM_ALLOCATED because it is local symbol
         NOTE:
         When compared then this symbol _have to_ be type casted
         to SYMBOLSCOPE. If it will be not type casted then some
         compilers will compare (int)-1 with (char)-1 which is never
         true! (I am changing it for the second time :)

19990808-11:50 GMT+1 Victor Szel <info@szelvesz.hu>
   * source/runner/runner.c
     source/runner/Makefile
     include/run_exp.h
     ! Some missed name changes adapted.
   * source/rtl/errorapi.c
     ! hb_vmPushlogical() uses BOOL.
     + Some improvement in _errLaunch().

19990808-10:05 GMT+1 Antonio Linares <alinares@fivetech.com>
   * makefile.b32
     * setkey and devoutp were not properly referenced

19990808-09:34 GMT+1 Antonio Linares <alinares@fivetech.com>
   * source/rtl/tbrowse.prg
     * improved
   * tests/working/TestBrw.prg
     * improved

19990808-23:33 EDT Paul Tucker <ptucker@sympatico.ca>
   * source/rtl/gt/gtwin.c
     + add missing =

19990808-03:00 GMT+1 Victor Szel <info@szelvesz.hu>
   * source/rtl/codebloc.c
     source/rtl/itemapi.c
     source/vm/hvm.c
     include/extend.h
     ! hb_Codeblock*() -> hb_codeblock*()
   * source/rtl/codebloc.c
     source/rtl/itemapi.c
     source/rtl/memvars.c
     source/vm/hvm.c
     include/extend.h
     ! hb_Memvar*() -> hb_memvar*()
   * source/vm/hvm.c
     ! Fixed and updated declaration list for HARBOUR functions.
   * source/rdd/dbcmd.c
     source/rtl/arrays.c
     source/rtl/classes.c
     source/rtl/do.c
     source/rtl/errorapi.c
     source/rtl/itemapi.c
     source/rtl/transfrm.c
     source/runner/runner.c
     source/vm/hvm.c
     source/vm/initsymb.c
     include/ctoharb.h
     include/hb_vmpub.h
     * All function belonging to the vm renamed to hb_vm*()
   * source/tools/debug.c
     ! Some functions made static.
   * source/vm/hvm.c
     % Some variable declarations moved to the block which uses it.
   * source/vm/hvm.c
     include/ctoharb.h
     * PushLogical(), PopLogical() uses BOOL instead of int.
   * source/vm/hvm.c
     include/extend.h
     include/ctoharb.h
     * declarations belonging to the vm moved to ctoharb.h
     * declarations belonging to extend moved to extend.h (ulMemory* variables)
   * source/rtl/console.c
     source/rtl/copyfile.c
     source/tools/debug.c
     ! Removed #include "ctoharb.h"
   * source/rtl/gt/gtwin.c
     ! Fixed warning about missing parenthesis.
   * include/ctoharb.h
     ! #include "extend.h"
   * source/runner/runner.c
     ! HB_HB_RUN -> HB_MAIN - So it now works with Win32/GCC.
       (this change belongs to 19990807-22:55 GMT+1)

19990808-17:25 EDT Paul Tucker <ptucker@sympatico.ca>
   * makefile.vc
     + debug.lib
     + menuto
   * source/rtl/buildvc.bat
     + debug.lib

19990807-22:55 GMT+1 Victor Szel <info@szelvesz.hu>
   * builddos.bat
     makedos.env
     makefile.dos
     source/compiler/makefile.dos
     source/makefile.dos
     source/rdd/dbfntx/makefile.dos
     source/rdd/makefile.dos
     source/rtl/makefile.dos
     source/tools/makefile.dos
     source/vm/makefile.dos
     tests/working/biccexe.cmd
     tests/working/hbdos.bat
     tests/working/hbicc.cmd
     tests/working/makefile.dos
     tests/working/makerunr.dos
     tests/working/runrdos.bat
     Removing all makefiles related to IBM C and the non-GNU makefiles
     for DOS/DJGPP.
   * source/rtl/error.prg renamed to
     source/rtl/terror.prg
     makefile.*
   * source/hbpp/Makefile
     - Removed unused parts for making standalone version
   * source/rtl/Makefile
     source/tests/working/Makefile
     source/debug/Makefile
     source/Makefile
     + source/rtl/tbrowse.prg
     + source/rtl/tbcolumn.prg
     + source/debug/debugger.prg
     + tests/working/testbrw.prg
   * source/rtl/alert.prg
     ! Fixed handling of parameters of other types than string and array.
   * source/rtl/asort.prg
     ! Fixed, so that it will now return NIL when the first parameter is not
       an array, just like Clipper.
   * source/rtl/errorapi.c
     ! hb_errLaunch() interprets the non logical return value of the
       error handler as an E_DEFAULT, some other small improvements.
   * source/rtl/menuto.prg
     ! Fixed errorblock return value.
     ! Fixed deleted assigment to the variable n
   * source/rdd/dbcmd.c
     source/rtl/classes.c
     source/rtl/do.c
     source/rtl/errorapi.c
     source/rtl/itemapi.c
     source/rtl/memvars.c
     source/rtl/transfrm.c
     source/runner/runner.c
     source/vm/dynsym.c
     source/vm/hvm.c
     * hb_*DynSym() functions renamed to hb_dynsym*() format.
   * include/extend.h
     source/vm/dynsym.c
     * SYM_ALLOCATED renamed to FS_ALLOCATED and moved to extend.h
       from dynsym.c (is this right ?)
   * include/langapi.h
     + Some new declarations.

19990808-17:25 EDT Paul Tucker <ptucker@sympatico.ca>
   * tests/working/Makefile
     -debugger
     +cursrtst
   + tests/working/cursrtst.prg

19990808-15:00 EDT Paul Tucker <ptucker@sympatico.ca>
   * makefile.vc
     + source/rtl/tbrowse.prg
     + source/rtl/tbcolumn.prg
     + source/debug/debugger.prg
     + tests/working/testbrw.prg
   * source/rtl/gtapi.c
     -hb_gt_ScreenBuffer
   * include/gtapi.h
     -hb_gt_ScreenBuffer
   * source/rtl/gt/gtwin.c source/rtl/gtdos.c
     + Improved or added Dispbegin/end support
     * minor corrections in gtdos
   * source/rtl/gt_tpl.c
     + dummy hb_gt_Set/GetBlink hb_gt_replicate
   * source/rtl/gtos2.c
     + dummy hb_gt_Set/GetBlink hb_gt_replicate
     * corrected parameter order as reported by Davig G. Holme
       NOTE: cursor sizes are not correct in this version.

19990808-01:00 GMT+1 Antonio Linares <alinares@fivetech.com>
   * source/rtl/tbrowse.prg
     * tag added
   * source/rtl/tbcolumn.prg
     * tag added
   * tests/working/TestBrw.prg
     * tag added

19990807-19:34 GMT+1 Antonio Linares <alinares@fivetech.com>
   * source/rtl/tbrowse.prg
     * improved
   * source/rtl/tbcolumn.prg
     * improved
   * tests/working/TestBrw.prg
     * improved

19990807-18:51 GMT+1 Antonio Linares <alinares@fivetech.com>
   * source/rtl/tbrowse.prg
     * improved
   * tests/working/TestBrw.prg
     * improved

19990807-18:40 GMT+1 Bruno Cantero <bruno@issnet.net>
   * include/rddapi.h
     source/rdd/dbcmd.c
     source/rdd/dbf0.prg
     source/rdd/dbf1.c
     source/rdd/delim0.prg
     source/rdd/delim1.c
     source/rdd/sdf0.prg
     source/rdd/sdf1.c
     source/rdd/dbfntx/dbfntx0.prg
     source/rdd/dbfntx/dbfntx1.c
     More RDD functions: addField, createFields, setFieldExtent, info,
     newArea, release and sysName

19990807-22:00 WIB Andi Jahja
  * source/rtl/asort.prg
    bug fix when sorting an empty array

19990807-12:54 GMT+1 Antonio Linares <alinares@fivetech.com>
   * source/rtl/tbrowse.prg
     * improved
   * source/rtl/tbcolumn.prg
     * improved
   * tests/working/TestBrw.prg
     * improved

19990807-11:37 GMT+1 Antonio Linares <alinares@fivetech.com>
   * source/rtl/tbrowse.prg
     * Some methods added

19990807-10:17 CET Patrick Mast <harbour@PatrickMast.com>
   * removed debugger.prg from /tests/working

199908.07-12:03 GMT+3 Alexander Kresin
  * makefile.b32
    * added 'source/debug' to .prg path for build32.bat to work

19990807-9:38 GMT+1 Antonio Linares <alinares@fivetech.com>
   * tests/working/hb32.bat
     * Second supplied parameter is a compiler flag
   * source/rtl/tbrowse.prg
     * Some methods added

19990807-9:19 GMT+1 Antonio Linares <alinares@fivetech.com>
   * source/compiler/harbour.y
     * Debugger() symbol requested when compiling using /b
   * source/vm/hvm.c
     * ModuleName() automatically invokes Debugger() if module compiled using /b

19990807-8:39 GMT+1 Antonio Linares <alinares@fivetech.com>
   + source/rtl/tbcolumn.prg
     * Harbour Class TBColumn first outline
   * tests/working/testbrw.prg
     * Updated
   * makefile.b32
     * tbcolumn module added

19990807-8:39 GMT+1 Antonio Linares <alinares@fivetech.com>
   + source/rtl/tbrowse.prg
     * Harbour Class TBrowse first outline
   + tests/working/testbrw.prg
     * Harbour Class TBrowse sample
   * makefile.b32
     * tbrowse module added

Fri Aug 06 20:04:05 1999  Gonzalo A. Diethelm  <Gonzalo.Diethelm@jda.cl>

        * config/rules.cf:
        Added the removal of *.core to the clean target.

        * source/hbpp/hbpp.c:
        * source/hbpp/stdalone/hbpp.c:
        Fixed two unused variable warnings.

199908.06-22:12 GMT+3 Alexander Kresin
  * include/hbpp.h
  * source/hbpp/hbpp.c
  * source/hbpp/hbppint.c
  * source/hbpp/table.c
    * fixed some bugs
    * linked list for #commands and #translates storage instead or array
  * source/hbpp/stdalone/hbpp.c
    * added run-time messages
    * creation of table.c contens

19990806-19:55 GMT+1 Antonio Linares <alinares@fivetech.com>
   * include/classes.ch
     * Added support for SETGET methods

19990806-19:55 GMT+1 Antonio Linares <alinares@fivetech.com>
   * makefile.b32
     * hvm module added
   * tests/working/bld32exe.bat
     * removed hvm.c module

19990806-19:35 GMT+1 Antonio Linares <alinares@fivetech.com>
   * include/pcode.h
     + Added new HB_P_LOCALNAME opcode
   * source/compiler/harbour.y
     + Added support for HB_P_LOCALNAME opcode
   * source/vm/hvm.c
     + Added support for HB_P_LOCALNAME opcode

19990806-18:43 GMT+1 Antonio Linares <alinares@fivetech.com>
   * include/pcode.h
     + Added new HB_P_MODULENAME opcode
   * source/compiler/harbour.y
     + Added support for /b compiler flag
     + Added support for HB_P_MODULENAME opcode
   * source/vm/hvm.c
     + Added support for HB_P_MODULENAME opcode

19990806-10:45 GMT+1 Antonio Linares <alinares@fivetech.com>
   * makefile.b32
     * updated with latest modules

19990806-01:40 EDT Paul Tucker <ptucker@sympatico.ca>
   * makefile.vc
     + readvar.prg

19990806-05:31 GMT+1 Victor Szel <info@szelvesz.hu>
   * source/rtl/menuto.prg
     ! MENU TO made highly Clipper compatible (100%), with the addition of
       the nesting capability.
       (only BEGIN/END SEQUENCE and Break() support is missing)
   * make_tpl.bat
     make_tpl.cmd (added)
     make_tpl.sh
     * Updated and extended make starter files.
   * source/rtl/readvar.prg
     source/rtl/Makefile
     funclist.txt
     + Added: READVAR() (used in MENU TO)
      (*** Please update other makefiles accordingly ***)
   * include/Makefile
     ! hb_vmpub.h added
   * source/rtl/achoice.prg
     ! Fixed handling of Ctrl+PgUp/PgDn/Home/End when a user func was passed.
   * source/rdd/dbcmd.c
     source/rtl/classes.c
     source/rtl/do.c
     source/rtl/memvars.c
     source/runner/runner.c
     source/vm/dynsym.c
     source/vm/hvm.c
     include/extend.h
     include/hb_vmpub.h
     * DYNSYM -> HB_DYNS
       PDYNSYM -> PHB_DYNS
   * include/*.* - More small cleanups

19990805-17:10 GMT+1 Victor Szel <info@szelvesz.hu>
   * source/rtl/setcolor.c
     ! #includes "extend.h" instead of "pcode.h"
   * source/compiler/harbour.y
     include/hb_vmpub.c
     % New header file which contains only those definitions which are
       a must to compile a Harbour generated C file.
   * source/rtl/natmsg/msghe862.c
     source/rtl/natmsg/msghewin.c
     source/rtl/msgxxx.c
     + Hebrew language files added
       (Posted by Chen Kedem <niki@synel.co.il>)
   * source/rtl/Makefile
     source/rtl/menu.prg (removed)
     source/rtl/menuto.prg (added)
     tests/working/testmenu.prg (removed)
     tests/working/menutest.prg (added)
     tests/working/Makefile
     + New MENU TO implementation (Phil Barnett)
       which is highly Clipper compatible. (nesting, color and setting
       buffering, setkey, some side effects simulated, output redir behav.)
       "~" hotkey char support removed, since there's no such in Clipper.
     + Test includes recursive capability
     ! Test added to Makefile
      (Please update other makefiles accordingly)
   * source/rtl/achoice.prg
     + Added SETKEY() handling.
   * source/rtl/alert.prg
     ! HARBOUR_STRICT_CLIPPER_COMPATIBILITY mode bug fixed.
   * include/extend.h
     - Removed obsolete SYMBOL type.
   * include/pcode.h
     source/compiler/harbour.y
     - #include "extend.h" removed from pcode.h
   * include/hbdefs.h
     include/extend.h
     include/filesys.h
     include/rddapi.h
     include/rddapi.h
     source/rdd/dbf1.c
_LOCALNAME opcode

19990806-18:43 GMT+1 Antonio Linares <alinares@fivetech.com>
   * include/pcode.h
     + Added new HB_P_MODULENAME opcode
   * source/compiler/harbour.y
     + Added support for /b compiler flag
     + Added support for HB_P_MODULENAME opcode
   * source/vm/hvm.c
     + Added support for HB_P_MODULENAME opcode

19990806-18:00 WIB Andi Jahja
   * source/rtl/menuto.prg
     - added error checker

19990806-10:48 GMT+1 Victor Szel <info@szelvesz.hu>
   * source/rtl/classes.c
     ! One cast added back.

19990806-10:45 GMT+1 Antonio Linares <alinares@fivetech.com>
   * makefile.b32
     * updated with latest modules

19990806-01:40 EDT Paul Tucker <ptucker@sympatico.ca>
   * makefile.vc
     + readvar.prg

19990806-05:31 GMT+1 Victor Szel <info@szelvesz.hu>
   * source/rtl/menuto.prg
     ! MENU TO made highly Clipper compatible (100%), with the addition of
       the nesting capability.
       (only BEGIN/END SEQUENCE and Break() support is missing)
   * make_tpl.bat
     make_tpl.cmd (added)
     make_tpl.sh
     * Updated and extended make starter files.
   * source/rtl/readvar.prg
     source/rtl/Makefile
     funclist.txt
     + Added: READVAR() (used in MENU TO)
      (*** Please update other makefiles accordingly ***)
   * include/Makefile
     ! hb_vmpub.h added
   * source/rtl/achoice.prg
     ! Fixed handling of Ctrl+PgUp/PgDn/Home/End when a user func was passed.
   * source/rdd/dbcmd.c
     source/rtl/classes.c
     source/rtl/do.c
     source/rtl/memvars.c
     source/runner/runner.c
     source/vm/dynsym.c
     source/vm/hvm.c
     include/extend.h
     include/hb_vmpub.h
     * DYNSYM -> HB_DYNS
       PDYNSYM -> PHB_DYNS
   * include/*.* - More small cleanups

19990805-17:10 GMT+1 Victor Szel <info@szelvesz.hu>
   * source/rtl/setcolor.c
     ! #includes "extend.h" instead of "pcode.h"
   * source/compiler/harbour.y
     include/hb_vmpub.c
     % New header file which contains only those definitions which are
       a must to compile a Harbour generated C file.
   * source/rtl/natmsg/msghe862.c
     source/rtl/natmsg/msghewin.c
     source/rtl/msgxxx.c
     + Hebrew language files added
       (Posted by Chen Kedem <niki@synel.co.il>)
   * source/rtl/Makefile
     source/rtl/menu.prg (removed)
     source/rtl/menuto.prg (added)
     tests/working/testmenu.prg (removed)
     tests/working/menutest.prg (added)
     tests/working/Makefile
     + New MENU TO implementation (Phil Barnett)
       which is highly Clipper compatible. (nesting, color and setting
       buffering, setkey, some side effects simulated, output redir behav.)
       "~" hotkey char support removed, since there's no such in Clipper.
     + Test includes recursive capability
     ! Test added to Makefile
      (Please update other makefiles accordingly)
   * source/rtl/achoice.prg
     + Added SETKEY() handling.
   * source/rtl/alert.prg
     ! HARBOUR_STRICT_CLIPPER_COMPATIBILITY mode bug fixed.
   * include/extend.h
     - Removed obsolete SYMBOL type.
   * include/pcode.h
     source/compiler/harbour.y
     - #include "extend.h" removed from pcode.h
   * include/hbdefs.h
     include/extend.h
     include/filesys.h
     include/rddapi.h
     include/rddapi.h
     source/rdd/dbf1.c
     source/rdd/dbfntx/dbfntx1.c
     source/rdd/dbcmd.c
     source/rtl/gt/gtos2.c
     source/rtl/copyfile.c
     source/rtl/environ.c
     source/rtl/filesys.c
     source/runner/runner.c
     source/vm/hvm.c
     source/tools/hb_f.c
     Non Harbour standard, sparsly used and redundant types removed.
     - PBYTE -> BYTE * (few occurences)
       BYTEP -> BYTE * (few occurences, non standard)
       PVOID -> void * (1 occurence)
       FARPP -> void ** (few occurences)
       FARP  -> void * (few occurences)

19990805-04:47 GMT+1 Victor Szel <info@szelvesz.hu>
   * source/rtl/console.c - Small var naming change.
   * source/rtl/achoice.prg
     ! Fixed: SET DEVICE is no longer redirecting it's output.
     % Optimalized color handling. (Thanks to Paul Tucker)

19990804-14:30 EDT Paul Tucker <ptucker@sympatico.ca>
   * source/rtl/filesys.c
     * added a cast (reported by Matteo)

19990804-20:30 GMT+1 Victor Szel <info@szelvesz.hu>
   * source/rtl/achoice.prg
     + Uses __COLORINDEX()
   * source/rtl/console.c
     tests/working/colorind.prg
     ! __COLORINDEX() small bug fixed related to trimming trailing spaces.
     ! expected test results updated.

19990804-20:00 GMT+1 Victor Szel <info@szelvesz.hu>
   * source/rtl/console.c
     tests/working/colorind.prg
     tests/working/Makefile
     source/rtl/tget.prg
     + Added function: __COLORINDEX().
     ! TGET modified to use __COLORINDEX() instead of STRTOKEN()
   * source/rtl/Makefile
     source/rtl/stringsx.c
     source/tools/stringsx.c
     ! STRTOKEN() put back to TOOLS.

19990804-00:40 EDT Paul Tucker <ptucker@sympatico.ca>
   * makefile.vc
     + tget tgetlist langapi

19990804-19:07 GMT+1 Victor Szel <info@szelvesz.hu>
   + include/langapi.h
     Added. (Missed from the previous CVS session, sorry)

19990804-00:40 EDT Paul Tucker <ptucker@sympatico.ca>
   * source/rtl/gtwin.c
      * reduced the internal buffering to 1 level to improve speed.
   * source/rtl/gtapi.c
      * commented out dispbegin calls in gtbox (for now!)

Wed Aug 04 12:25:12 1999  Gonzalo A. Diethelm  <Gonzalo.Diethelm@jda.cl>

        * source/rdd/dbcmd.c:
        Got rid of the bell (0x07) character printed in error messages; it
        tends to screw up in some consoles.
        Changed hb_rddRegister() to return an int rather than a bool, so
        now it is possible to return different status values.
        Now trying to register the same RDD more than once is a NOOP.

        * source/rdd/dbfntx/dbfntx0.prg:
        KLUDGE ALARM: since the DBFNTX driver depends on the DBF driver,
        and the order of INIT procedures is not guaranteed (and is
        actually the wrong order under gcc/Win32), I forced the
        initialization of DBF before DBFNTX.

19990804-17:30 GMT+1 Victor Szel <info@szelvesz.hu>
  * source/rtl/msgxxx.c
    - __TURBOC__ branch deleted.
  * source/rtl/alert.prg
    + Added the handling of first parameters of Alert() if they are not strings.
  * source/rtl/copyfile.c
    + Changed to use: hb_errorRT_BASE_Ext1()
      So now it can retry or default.
  * source/rtl/errorapi.c
    include/rtl/errorapi.h
    + Added: hb_errorRT_BASE_Ext1()
    + Added: hb_errorRT_New() (static)
    ! Fixed: hb_errorLaunch() so that it converts the logical
      value returned by the codeblock to a number.
    + Added: hb_errorLaunch() some notes about internal error which can occur
      here.
  * source/rtl/errorsys.prg
    + Added: Alert() box.
  * source/rtl/msgxxx.c (code moved away from here)
    source/rtl/classes.c
    source/rtl/errorapi.c
    source/vm/hvm.v
    + Uses Language API instead of hb_errorNat...() function.
  * source/vm/hvm.c
    ! LONG lLineNo -> WORD wLineNo to suppress a warning.
  * include/langapi.h
    source/rtl/langapi.c
    + Language API initial implementation.
  * source/rtl/vm/ForTest()
    - Removed the "internal error" which stated that there will
      be infinite loop if STEP 0 is used, Clipper just goes into an
      ininite loop.
    ! Changed printf() to a standard error is STEP expression is not numeric.
  * include/errorapi.h
    source/rtl/errorapi.c
    source/rtl/msgxxx.c
    source/rtl/msg*.c
    + Added internal error launcher API call hb_errorInternal()
  * source/hbpp/hbpp.c
    include/hberrors.h
    * "#error" message standardized, made Clipper like.
  * tests/working/Makefile
    tests/working/dyssym.prg
    + __DYNSYM*() tests added.
  * include/Makefile
    include/initsymc.h (renamed from initsymb.h)
    include/initsymd.h (added)
    source/vm/initsymb.c
    source/runner/runner.c
    Init function extern declarations put into initsymd.h
  * source/vm/dynsym.c
    * Name changes:
      HB_DYNSYMBOLS -> HB___DYNSYMCOUNT
      HB_DYNSYMNAME -> HB___DYNSYMGETNAME
      HB_GETDYNSYM  -> HB___DYNSYMGETINDEX
  * source/runner/runner.c
    ! Using "ctoharb.h"
  * source/rtl/gt/gtwin.c
    ! Compiler warning corrected.
  * source/rtl/achoice.prg
    % Some small optimalizations, userfunc as codeblock support documented.
  * source/rtl/alert.prg
    + Added TOFIX: DispBegin issue.
  * include/ctoharb.h
    include/extend.h
    include/init.h
    source/vm/initsymb.c
    source/vm/hvm.c
    source/vm/dynsym.c
    source/rtl/memvars.c
    source/rtl/codebloc.c
    source/rtl/classes.c
    source/runner/runner.c
    source/compiler/genobj32.c
    * SYMBOL -> HB_SYMB
      PSYMBOL -> PHB_SYMB
  * tests/working/Makefile
    + debugger.prg and testread.prg added
  * source/rtl/tget.prg
    source/rtl/tgetlist.prg
    tests/working/testread.prg
    tests/working/debugger.prg
    + CVS tags added.
  * source/rtl/Makefile
    + Added tget*.prg

Wed Aug 04 11:00:07 1999  Gonzalo A. Diethelm  <Gonzalo.Diethelm@jda.cl>

        * source/tools/stringsx.c:
        * source/rtl/Makefile:
        * source/rtl/stringsx.c:
        Moved STRTOKEN from tools/ to rtl/, even though it is not a 100%
        Clipper standard function. The reason is because we will probably
        be using this function a lot (such as Antonio did in TGet.prg).

        * source/rtl/gt/gtwin.c:
        * source/vm/hvm.c:
        Fixed two minor warnings.

Wed Aug 04 10:12:24 1999  Gonzalo A. Diethelm  <Gonzalo.Diethelm@jda.cl>

        * config/win32/gcc.cf:
        Got rid of -( and -).

        * tests/working/Makefile:
        Corrected the order of the libraries to link against.

199908.04-16:32 GMT+3 Alexander Kresin
  * source/hbpp/table.c
    * change in @ y,x GET ...

19990804 GMT+1 Antonio Linares <alinares@fivetech.com>
  + source/rtl/TGet.prg added
    Harbour Class TGet (developed by Ignacio Ortiz)
  + source/rtl/TGetList.prg added
    Harbour Class TGetList (object oriented implementation of Clipper
    language GetSys.prg)
  * makefile.b32
    + TGet.prg and TGetList.prg modules added.
    * Alphabetically sorted names.
    * Please note I have not updated other makefiles
  + tests/working/TestRead.prg added
    * @ ... GET and READ sample
  * source/compiler/harbour.y
    * Fixed VarDef IDENTIFIER '[' ExpList ']' rule
  * source/vm/hvm.c
    * Added support for DimArray() just for one dimension
      (it generates an error and exists if trying to build a more
       than one dimensions array).

199908.04-11:35 GMT+3 Alexander Kresin
  * source/hbpp/hbpp.c
    * Some bugs fixed,mentioned by Victor Szel, Matteo Baccan and David G. Holm
  * makefile.b32
    * msgxxx.c replaced with msguk.c
  * config/win32/bcc32.cf
    * LD = bcc32

19990804-00:40 EDT Paul Tucker <ptucker@sympatico.ca>
  * source/rtl/gt/gtwin.c
   * better selection of default screen size reported by MaxRow/Col

19990804-00:35 EDT David G. Holm <dholm@jsd-llc.com>
  * source/vm/hvm.c
    ! Corrected Power() to set the correct number of decimal points.
  * tests/working/build.bat
    + Added checks for HB_ARCHITECTURE and HB_COMPILER.
    + Modified to always build the target.

19990804-00:40 EDT Paul Tucker <ptucker@sympatico.ca>
  * source/rtl/gt/gtwin.c
    * corrected screen buffer size for dispbegin
  * makefile.vc
    + adir.prg
    + setkey.prg
    * Corrections to Achoice, filesys
  * re-enabled gtDispbegin/end calls in gtBox

19990804-00:20 EDT David G. Holm <dholm@jsd-llc.com>
  + tests/working/build.bat
    + New batch file to build and run individual PRG files
      Syntax: "BUILD module", where module is the main part of the
      file name of the PRG file to be built and run. For example,
      to build and run T.PRG, use "BUILD T".

19990804-00:15 EDT David G. Holm <dholm@jsd-llc.com>
  * source/rtl/math.c
    ! Corrected MOD() to set the correct number of decimal points.
  * source/vm/hvm.c
    ! Corrected Div() to set the correct number of decimal points.
    ! Corrected Modulus() to use fmod() instead of the % operator.
    ! Corrected Modulus() to set the correct number of decimal points.

19990803-22:10 EDT David G. Holm <dholm@jsd-llc.com>
  * source/rtl/setcolor.c
    + Added missing '#ifdef HARBOUR_USE_GTAPI'.
  * source/rtl/gt/gtos2.c
    + Added missing 'char' type on 'cRight' parameter for
      both hb_gt_SetAttribute() and hb_gt_DrawShadow().

19990803-21:20 EDT Paul Tucker <ptucker@sympatico.ca>
  * source/rtl/gt/gtwin.c
    * SetCursor fixed

19990803-22:30 GMT+1 Victor Szel <info@szelvesz.hu>
  * source/rtl/gtapi.c
    include/gtapi.h
    + hb_gtGetBlink() added.
    (still dummy though)
  * source/rtl/console.c
    + SETBLINK() added.
  * source/rtl/filesys.c
    source/rtl/Makefile
    tests/working/curdirt.prg
    tests/working/Makefile
    + CURDIR() plus test program CURDIRT added.
      (Please update other makefiles accordingly)
      Note that hb_fsCurDir() is not fully implemented yet,
      so the test will not work like Clipper.
  * source/rtl/setcolor.c
    + COLORSELECT() added.
  * source/rtl/adir.prg
    source/rtl/Makefile
    tests/working/adirtest.prg
    tests/working/Makefile
    + ADIR() plus test program ADIRTEST added.
      (Please update other makefiles accordingly)
  * funclist.txt
    * Updated statuses
    + Added some functions (_fs*())
  * doc/codestyl.txt
    + "NOTE:" Added
  * tests/working/descend.prg - Byref test added.

19990803-19:00 GMT+1 Victor Szel <info@szelvesz.hu>
  * source/rtl/achoice.prg
    source/rtl/Makefile
    tests/working/ac_test.prg
    tests/working/Makefile
    + ACHOICE() plus test program AC_TEST added.
      (Please update other makefiles accordingly)
  * include/box.ch
    include/box.h
    + XBase++ compatible B_THIN, B_FAT border types added.
  * include/memoedit.ch
    + Some XBase++ extensions added.

19990803-16:50 GMT+1 Victor Szel <info@szelvesz.hu>
  * config/win32/gcc.cf
    config/os2/gcc.cf (not tested)
    ! Fixed rddtest linking failure, with method by Ryszard
      (also used in config/dos/djgpp.cf)
  * make_tpl.bat
    + C_USR, list of available commands, HB_*_INSTALL.
  * include/error.ch
    include/rddsys.ch
    include/set.ch
    include/fileio.ch
    include/color.ch
    include/setcurs.ch
    Added a note that these files are also used in C files.
  * include/inkey.ch
    + Added missing K_ definitions.
    * Converted so it can now be used in C.

Tue Aug 03 11:20:17 1999  Gonzalo A. Diethelm  <Gonzalo.Diethelm@jda.cl>

        * include/rddapi.h:
        Changed all #ifdef 0 with #if 0, assuming the original intent was
        to comment those sections out.

        * source/rtl/gt/gtwin.c:
        Moved an unused variable within the commented out portion of the
        code where it was used.

19990803-14:55 GMT+1 Victor Szel <info@szelvesz.hu>
  ! source/rtl/strings.c - ASC() fixed. It could return negative values
    since a typecase (BYTE) was missing.
  ! source/rtl/descend.c
    * Fixed so that it's returning NIL type
      on bad parameter type, and not "NIL" as a string.
    * Fixed Chr(0) handling in the middle of the string.
    * Fixed so that it returns DOUBLE type even when an integer
      is passed, just like in Clipper.
  + tests/working/descend.prg - Output to STD, plus some new tests.
  ! source/rtl/console.c
    makefile.b16
    makefile.b31
    terminal.b32
    WINDOWS define check removed. QOUT() will no longer
    throw a MessageBox() when compiled wit -DWINDOWS
    Since this by no means expected behaviour.
    To throw a MessageBox() one should call a user function
    to do this.
  - source/vm/hvm.c
    WINDOWS define check removed, since it was never defined,
    in any current build system.
  * include/rddapi.h
    "Translated" to English.
  + include/extend.h - Added hb_strdescend() function extern.
  + include/itemapi.h - Added type EVALINFO_PTR
  ! include/Makefile - Completed file lists.

19990803-12:22 GMT+1 Victor Szel <info@szelvesz.hu>
   ! include/rddapi.h
     ITEM -> PHB_ITEM
     #ifdef COMMENT -> #ifdef 0
   + include/error.api
     ERRORP definition added.
   ! include/itemapi.h - HB_EVAL_PARAM_MAX_ set back to 9
   + include/*.api - #include all the things they include in original
     CA-Cl*pper. (*.api, clipdefs.h)
     Some other CA-Cl*pper compatible typedefs added.
   + include/fm.api - Some Clipper'87 compatible memory alloc functions
     added, also contained in CA-Cl*pper.
     _exmgrab(), _exmback (anyone using these ? 8-)
   ! include/filesys.h
     source/rtl/files.c
     ERRORP -> PHB_ITEM
   * source/rtl/files.c -> source/rtl/filesys.c
     source/rtl/Makefile
     makefile.*
   ! makefile.b31 - Fixed a bug where filesys.obj depended on extend.c
   + include/filesys.api
     include/extend.api - Some more CA-Cl*pper defines added.
   * source/rtl/gt/gtwin.c
     __CYGWIN32__ -> __CYGWIN__
     Since Cygnus's wrote somewhere that the "32" will be removed
     in the future versions of Cygwin GCC.
   * include/gtapi.h - Platform detection code moved to
     include/hbsetup.h
     BTW, it seems that it's not used anywhere yet.

19990803-04:50 EDT Paul Tucker <ptucker@sympatico.ca>
   * source/rtl/codebloc.c source/rtl/memvars.c
     + #include "itemapi.h"
     (also reported by Matteo Baccan)

19990803-04:15 EDT Paul Tucker <ptucker@sympatico.ca>
   + source/rtl/gt/gt_tpl.c
      * renamed source/rtl/gt/gtxxx.c since it's a template.
   * source/rtl/gt/gtwin.c
      * major changes
        Working DispBegin/DispEnd - original was leaving screen turds when
        running in a window (hard to figure out, easy to fix)
   * source/rtl/gtapi.c
      * minor changes
      * changed SetMode() executed at startup to default to your
        screen size.
        (Movie humour: This program has been modified to fit your screen
                     : How do you know how big my screen is?
         It's late)

19990803-05:30 GMT+2 Ryszard Glab <rglab@imid.med.pl>

    *tests/working/Makefile
        + added possibility to build a single file. Usage:
         make PM=file
         make PM=file.prg
         PM can be replaced with pm

    *source/compiler/harbour.y
        * DO .. WITH .. statement passes variables by reference now

    *source/vm/hvm.c
        * added reporting of line numbers in some internal errors

    *source/compiler/harbour.l
        * corrected missed line continuation with BREAK; EXIT; and LOOP;

19990802-20:00 EDT David G. Holm <dholm@jsd-llc.com>
   * config/os2/icc.cf
     * Added '/NOE' to 'AR_FLAGS' to get rid of linker errors for
       multiply defined and unresolved symbols.
   * config/win32/dir.cf
     ! Fixed COMMAND shell support .
   * config/win32/gcc.cf
     + Added 'moldname' to list of libraries to include
       (for hb_inkeyPoll() support).
   * config/win32/install.cf
     ! Fixed COMMAND shell support.
   * include/hbdefs.h
     ! Macros MAX and MIN are not types and must therefore be
       outside 'the #if ! defined(HB_DONT_DEFINE_BASIC_TYPES)'
       and '#if defined(__IBMCPP__)' type exclusion blocks.
   * include/inkey.h
     + Added extern prototype for hb_inkey().
   * source/hbpp/stdalone/hbpp.c
     * Changed #include tests to allow more compilers to build it.
   * source/rtl/console.c
     * Added code to switch stdout and errout from text mode to
       binary for Borland C, IBM C++, DJGPP, Cygwin, and MS C.
     * Changed HB___ACCEPT() to use hb_altout() instead of using a
       P-Code call to QOUT(). Changed HB_OS_DOS_COMPATIBLE version
       to use INKEY(). Moved the function to the bottom of the file
       in order to avoid having to add a prototype for hb_dispout().
   * source/rtl/dir.c
     ! Worked around bug where certain compilers that only have standard
       chmod() support were being treated as if they had Borland / DJGPP
       style _chmod() support, which resulted in OS/2 / GCC and Windows /
       GCC version of DIRTEST marking all files read only. Compilers that
       previously caused read-only files will no longer show attributes.
   * source/rtl/inkey.c
     - Removed __CYGWIN__ exclusion from hb_inkeyPoll().
     + Added comments to key translations.
     + Created hb_inkey() from the low-level guts of HB_INKEY, so that
       internal Harbour functions can get input events without having
       to resort to using a P-Code call to INKEY().
   * source/rtl/set.c
     * Added message with actual error for file create failure.
   * tests/working/cdow.prg
     * Changed CHR(10) to CHR(13)+CHR(10)
   * tests/working/dates.prg
     * Changed CHR(10) to CHR(13)+CHR(10)
   * tests/working/dates2.prg
     * Changed CHR(10) to CHR(13)+CHR(10)
   * tests/working/dates3.prg
     * Changed CHR(10) to CHR(13)+CHR(10)
   * tests/working/dates4.prg
     * Changed CHR(10) to CHR(13)+CHR(10)
   * tests/working/dirtest.prg
     * Attempt to determine if running on a DOS type system and
       use the result to determine whether to use CR,LF or LF.
   * tests/working/inherit.prg
     * Attempt to determine if running on a DOS type system and
       use the result to determine whether to use CR,LF or LF.
   * tests/working/inkeytst.prg
     + Added two command line parameters: If the first one is
       present, only the last test will be run. If the second
       one is present, extended keyboard codes are allowed.
   * tests/working/longstr2.prg
     * Attempt to determine if running on a DOS type system and
       use the result to determine whether to use CR,LF or LF.
   * tests/working/readfile.prg
     * Changed from having newline differ based on Clipper vs.
       Harbour to having it differ based on DOS vs. Unix.
   * tests/working/round.prg
     * Attempt to determine if running on a DOS type system and
       use the result to determine whether to use CR,LF or LF.
   * tests/working/seconds.prg
     * Attempt to determine if running on a DOS type system and
       use the result to determine whether to use CR,LF or LF.
   * tests/working/set_num.prg
     * Changed CHR(10) to CHR(13)+CHR(10)

19990802-19:45 GMT+1 Victor Szel <info@szelvesz.hu>
   + include/dates.h
     source/rtl/dates.c - const keyword added.
   - include/ctoharb.h - extern StackShow() removed.
   - include/set.h - HARBOUR externs removed.
   * include/extend.h hb_item*() moved to
     include/itemapi.h
     source/rtl/console.c
     source/rtl/transfrm.c
   * source/rtl/console.c
     source/rtl/strings.c
     include/itemapi.h - hb_str() -> hb_itemStr()
  %! source/rtl/transfrm.c - Fixed the case when no picture is passed.
     Got rid of NUMDEFAULT(). Now using hb_itemStr() instead of
     HARBOUR function callback to HB_STR(), some callbacks are still
     left though.
   * include/*.h - Some more cleanup.

19990802-18:23 GMT+1 Victor Szel <info@szelvesz.hu>
   + source/tools/mathx.c - Added PI()
     Posted by Matteo Baccan (baccan@isanet.it)

19990802-17:53 GMT+1 Victor Szel <info@szelvesz.hu>
   ! source/rtl/setkey.prg - Fix: aSetKeys := aClone( OldKeys )

19990802-10:50 EDT Paul Tucker <ptucker@sympatico.ca>
   * makefile.vc
     + added setkey
   * source/rtl/setkey.prg
     * fixed stray comment.

19990802-16:10 GMT+1 Victor Szel <info@szelvesz.hu>
   + include/extend.h
     _PTR flavour of pointer names added.
   * include/gtapi.h
     source/rtl/console.c
     source/rtl/gtapi.c
     source/rtl/gt/gt*.c
     gt*() -> hb_gt_*()
     hb_gt_DispBegin() color removed from the parameter list.
   + source/rtl/setkey.prg
     source/rtl/Makefile
     SetKey() function added.

19990802-15:20 GMT+1 Victor Szel <info@szelvesz.hu>
   % source/hbpp/hbpplib.c
     source/tools/debug.c
     source/tools/stringsx.c - Unused #includes removed
   + doc/codestyl.txt - Added. Moved here from source/vm/hvm.c
   * source/rtl/strings.c
     include/extend.h
     source/vm/dynsym.c - hb_strgreater() and hb_strupr() moved.
   * source/vm/dynsym.c
     source/vm/hvm.c
     LogSymbols() -> hb_LogDynSym()
     hb_ReleaseDynamicSymbols() -> hb_ReleaseDynSym()
   * source/rtl/classes.c
     source/runner/runner.c
     source/vm/hvm.c
     include/extend.h
     include/hbdefs.h - HARBOURFUNC -> PHB_FUNC
   + include/item.api
     include/itemapi.h - Moved #define ITEM PHB_ITEM to item.api, guard added.
   ! source/rtl/itemapi.c
     hb_itemGetDS() handling of the case when item is not a date
     fixed and made Clipper compatible.
     It will no longer place a \0 after the date. Clipper does the
     same, the NG is obviously wrong here, since it requires to pass
     an 8 byte buffer which is then supposed to hold an 8 chars date plus the
     terminating zero. Testing showed that Clipper doesn't place a \0.
   + include/extend.h
     source/rtl/arrays.c
     source/rtl/extend.c
     Change hb_arrayGetDate() to be thread safe by design,
     got rid of static buffer.
   + source/rtl/files.c/hb_fsCurDir() - Added TODO: Make it thread safe.
   % source/rtl/dates.c/STOD() - Some checkings removed, which had been
     moved to hb_retds() previously.
   + source/rtl/dates.c
     source/rtl/arrays.c
     source/rtl/extend.c
     source/rtl/itemapi.c
     include/dates.h
     hb_dateStrPut(), hb_dateStrGet() added. Redundant code converted
     to calls for these.
   * include/set.h - Extern decls moved to source/rtl/set.c and to
     source/vm/hvm.c
   * source/rtl/codebloc.c - Extern decls moved to include/extend.h
   * source/vm/initsymb.c - Extern decl moved to include/extend.h
   + include/*.h - extern keyword added to all extern declarations.
   ! include/item.api - _array* removed since not in Clipper.
   ! include/extend.api - _pcount, _reta removed since not in Clipper.
   ! include/gt.api - _gtInit removed since not in Clipper.
   ! include/vm.api - #include "extend.h" added.
   - include/compat.h
     include/super.h
     include/extra.h
     include/Makefile - Unused header files removed.
     They supposed to be used by Ad's RDD implementation.
   + include/itemapi.h
     source/rtl/itemapi.c
     The maximum number of parameters that could be addd with
     hb_EvalPutParam() can be set with a #define. Also 10 instead on 9
     parameters can be used now.
   % include/itemapi.h - Two unused variables removed from the EVALINFO
     structure.
   + include/extend.api
     include/extend.h
     source/rtl/extend.c - hb_parcsiz() added for Clipper compatibility.

19990802-05:30 EDT Paul Tucker <ptucker@sympatico.ca>
  * test/working/scroll.prg
    * added calls to dispbegin/dispend - nice & snappy now!

199908.02-12:15 GMT+3 Alexander Kresin
  * source/hbpp/hbpp.c
    * Bug fixed ( mentioned by Victor Szel )

19990802-02:30 EDT Paul Tucker <ptucker@sympatico.ca>
   * source/rtl/gtapi.c
     ! hb_gtDispbegin/end and hb_gtSetMode now supported for gtwin
     + hb_gt_ScreenBuffer - internal function for use by hb_gt_DispBegin/End
   * source/rtl/gtos2.c source/rtl/gtdos.c
     + dummy hb_gt_DispBegin, hb_gt_DispEnd and hb_gt_SetMode  (for now)
   * source/rtl/gtwin.c
     + hb_gt_DispBegin, hb_gt_DispEnd and hb_gt_SetMode
     * couple of comments in gtSetCursor along with a minor change
       due to cursor not always turning on when app quit.
   * source/rtl/inkey.c
     * updated a comment.
   * include/gtapi.h
     + hb_gt_DispBegin hb_gt_DispEnd hb_gt_ScreenBuffer hb_gt_SetMode
   * makefile.vc
     + added do

19990802-06:30 GMT+2 Ryszard Glab <rglab@imid.med.pl>

    *source/tools/strfmt.c
        * added (char *) type cast to call for hb_xgrab()

    *config/dos/djgpp.cf
    *config/linux/gcc.cf
        * changed to link correctly regardless the libraries order
         (the GCC linker searches the library only once by default)

    *source/rtl/classes.c
    *source/rtl/dates.c
    *source/rtl/files.c
    *source/rtl/inkey.c
    *source/rtl/math.c
    *source/rtl/memvars.c
    *source/rtl/strings.c
    *source/tools/dates2.c
    *source/vm/hvm.c
        * changed numbering of error subcodes

    *source/rtl/errorapi.c
        + added hb_errorRT_TOOLS() function

    *include/errorapi.h
        + added definition of HB_ERR_SS_TOOLS
        + added hb_errorRT_TOOLS() function

    *doc/subcodes.txt
        + added new file with proposed format for documenting of used
         error subcodes.

    *include/hberors.h
        + added new error code ERR_INVALID_LVALUE

    *source/compiler/harbour.y
        + added new error 'invalid lvalue' generated in cases like:
         alias->(var1, var2) := 0
        + enhanced support for DO <proc> WITH statement - procedure is
         called however variables are nnot passed by reference yet

    *source/vm/initsymb.c
        + updated systems symbols' table with HB_DO function

    *source/rtl/do.c
        + added new HARBOUR HB_DO function (visible in harbour as 'DO')
         that calls passed function/procedure.
         This function can be called directly passing the string with
         function/procedure name or passing a codeblock.
         This function is also used to implement DO <proc> WITH
         statement

    *source/rtl/Makefile
            + added new file do.c

19990801-21:58 GMT+1 Victor Szel <info@szelvesz.hu>
   % source/rtl/descend.c
     #include <ctype.h> removed
   ! source/compiler/harbour.y -
     hb_INITSTATICS() -> HB_INITSTATICS() (case adjusted)
     Change undone. Comment added to make this clear.

19990801-21:58 GMT+1 Bruno Cantero <bruno@issnet.net>
   * source/rdd/dbcmd.c
     Fixed a GPF with MSVC, thaks Paul

19990801-21:40 GMT+1 Victor Szel <info@szelvesz.hu>
   ! source/compiler/harbour.y
     source/hbpp/hbpplib.c
     source/odbc/odbc.c
     source/rtl/dates.c
     source/rtl/dir.c
     source/tools/dates2.c
     include/rddapi.h (some are still left)
     Changed all // style comments to /**/

19990801-20:40 GMT+1 Bruno Cantero <bruno@issnet.net>
   * source/rdd/rddsys.prg
     source/rdd/dbf0.prg
     source/rdd/sdf0.prg
     source/rdd/delim0.prg
     source/rdd/dbfntx/dbfntx0.prg
     tests/working/testdbf.prg
     Added a message for check if all the RDD's are linked

19990801-20:20 GMT+1 Bruno Cantero <bruno@issnet.net>
   * source/rtl/files.c
     Changed for MSVC
   * tests/working/buildvc.bat
     Added a include path to harbour

19990801-18:14 CET Victor Szel <info@szelvesz.hu>
   ! source/compiler/harbour.y -
     hb_INITSTATICS() -> HB_INITSTATICS() (case adjusted)
   + source/rdd/nulsys/nulsys.prg - Using ANNOUNCE
   ! source/rtl/mtran.c - Fixed, now 100% Clipper compatible.
     - HARD and SOFT characters swapped.
     - HARD and SOFT characters pairs are changed to only one
       character, like in Clipper.
     - unnecessary include ctype.h removed.
   ! source/rtl/hardcr.c
     - unnecessary include ctype.h removed.
     - "HARD_" -> "SOFT_" #define names corrected.
   + tests/working/mtran.prg - More extensive tests added.
   ! source/rtl/msgxxx.c - Previous changes undone, to make it work in GCC.
   + source/tools/numtxten.prg
     source/tools/Makefile
     NumToTxtEN() - English language number to text conversion added.
     Author: "Michael Mozina" <et@snowcrest.net> Donated to the Public Domain.

199908.01-16:30 GMT+3 Alexander Kresin
  * source/hbpp/hbppint.c
    * Bug fixed ( related to line continuation )

199908.01-20:30 WIB Andi Jahja
  * msgxxx.c
    correct directives, it now works

199908.01-16:30 GMT+3 Alexander Kresin
  * hbpplib.b32
    * it works now

19990801-13:14 GMT+1 Antonio Linares <alinares@fivetech.com>
   * tests/working/debugger.prg
     * pulldown menu already functional.

19990801-07:45 GMT+2 Ryszard Glab <rglab@imid.med.pl>

    *source/rtl/inkey.c
        * added #include <conio.h> for Watcom section

    *source/vm/hvm.c
        * the symbols are not scaned if there is no INIT/EXIT
          procedure in the module (this is checked at the time of
          symbol registration)
        * _INITSTATICS function is called directly (by pointer)
         instead of Do() function - it gives faster startup code
        * removed calls for hb_ItemClear for uninitialized data
         during startup code - these data have to be initialized
         by assigning the IT_NIL value
        - removed unnecessary calls for hb_itemClear in Push*
         functions (the number of calls decreased almost 3 times)
        * StackPop() clears now the last item on the stack
         (it clreared the first free previously)
        + added StackDec() that decrements the stack pointer but
         doesn't clear the item (hb_itemClear() must be called
         when this item is no longer needed)
         * storing/restoring of private variables stack position moved
         to VirtualMachine function

    *source/rtl/itemapi.c
        + added checking for proper type before calling hb_itemClear

    *include/rddapi.h
        * added forward declaration for _RDDFUNC struct

    *config/dos/watcom.cf
        * changed to support new RDD directory structure

    *source/rdd/dbcmd.c
        * removed #ifdef _MSC_VER that was placed before some
         type casting - this type casting should be included for
         all compilers

    *source/runner/runner.c
        * corrected to properly call static variable initialization
         function before other INIT functions

    *include/run_exp.h
        + added symols: __MVPUBLIC, __MVPRIVATE

    *source/runner/Makefile
        + added required libraries

    *include/extend.h
        * added declaration for hb_strMatchRegExp() function

    *source/rtl/strings.c
        * moved hb_strMatchDOS() function from rtl/dir.c
        * added hb_strMatchRegExp() function (it calls hb_strMatchDOS
         at this moment)

    *source/rtl/dir.c
        * moved hb_strMatchDOS() function to rtl/strings.c

     *source/hbpp/table.c
        * corrected entry for RELEASE command

     *source/rtl/memvars.c
        * corrected __MVXRELEASE function used in RELEASE statement
        + added __MVRELEASE function used in RELEASE ALL LIKE/EXCEPT

19990801-00:15 EDT Paul Tucker <ptucker@sympatico.ca>
   * source/rtl/gtapi.c
     * hb_gtScroll() - call gtScroll if WIN_GTAPI
   * source/rtl/gt/gtwin.c
     + gtScroll() Much improved scroll speed -not up to Clipper yet though.
   * include/gtapi.h
     + declaration for gtScroll()

19990731-23:20 GMT+1 Bruno Cantero <bruno@issnet.net>
   * source/rdd/dbcmd.c
     Forced to link rddsys.prg

19990731-17:00 EDT Paul Tucker <ptucker@sympatico.ca>
  * makefile.vc
    * moved contents of rdd.lib into harbour.lib
  * tests/working/buildvc.bat
    * removed reference to rdd.lib

19990731-22:27 GMT+1 Bruno Cantero <bruno@issnet.net>
   * makefile.dos
     Removed target 'nat'

19990731-22:17 GMT+1 Bruno Cantero <bruno@issnet.net>
   * include/rddapi.h
   * source/rdd/rddsys.prg
   * source/rdd/dbcmd.c
   * source/rdd/dbf1.c
   * source/rdd/delim1.c
   * source/rdd/dbfntx/dbfntx1.c
   * tests/working/testrdd.prg
     dbCreate() is finished!
   + tests/working/testdfb.prg
     This file create a DBF file

19990731-15:10 EDT Paul Tucker <ptucker@sympatico.ca>
  * makefile.vc
    * oodles of changes.
  * tests/working/buildvc.bat
    * added a couple of libs

19990731-22:55 Alexander Kresin
  * source\hbpp\hbpp.c
    * Fixed bugs mentioned by Victor Szel

19990731-20:16 GMT+1 Antonio Linares <alinares@fivetech.com>
   * tests\working\debugger.prg
     * improved sample.
   * rdd.b32
     * added delim... and sdf... modules
   * makefile.b32
     * little fixes

19990731-17:51 Alexander Kresin
  * source\hbpp\hbpp.c
    * Fixed problem with @ ::nTOP,... SAY ...
  * source\rdd\rddsys.prg
  * source\rdd\sdf0.prg
  * source\rdd\dbf0.prg
  * source\rdd\delim0.prg
  * source\rdd\dbfntx\dbfntx0.prg
     * Uncommented 'ANNOUNCE' - now it can be used

19990731-14:44 CET Victor Szel <info@szelvesz.hu>
   ! source/rtl/alert.prg - Handling of "*" in color string is
     made compatible with Clipper.
   - source/hbpp/buildgcc.bat - Removed. Use GNU Make instead.
   - include/fm.api - _xrealloc removed, since it was not there
     in Clipper.
   ! source/rtl/extend.c - "item.api" -> "itemapi.h"
   ! source/tools/hb_f.c - "filesys.api" -> "filesys.h"
   * tests/working/extend2.c - #include <x> -> "x"
   + funclist.txt - Extended with a huge amount of new functions, method
     and class variables. Please review it for your functions.

19990731-14:50 Alexander Kresin
  * source\hbpp\hbpp.c
  * source\hbpp\table.c
    * fixed some bugs, mentioned by Kwon,Oh-Chul ( ?"1234" ), Victor Szel
    * added support of letters, prefixed by '\' in rezult patterns
    * some other improvements that I don't remember already :)
    + added 'ANNOUNCE' keyword

19990731-11:40 CET Patrick Mast <harbour@PatrickMast.com>
   * updated build40.bat and makefile.b40

19990731-08:22 CET Victor Szel <info@szelvesz.hu>
   * source/rtl/natmsg/*.c
     GenericErrors renamed to hb_errorsGeneric
     static removed from the declarations.
   * source/rtl/msgxxx.c - Small cleanup.
   * source/rtl/natmsg/*.c
     source/rtl/msgxxx.c
     All files and language manifest constants renamed, so that
     they use the RFC language code.
     msgr1251 renamed to msgruwin, I may be wrong that
     codepage 1251 can be called russian windows codepage, but
     the name could not fit in 8 chars otherwise.
   * include/error.ch - Small modification.
   + source/rtl/natmsg.c - msg_tpl.c
     Added template language file. Contributors should use this to add
     support for a new language.
   + source/tools/Makefile
     source/tools/strfmt.c - StrFormat() added, see the file for
     documentation. StrFormat("%1 %2", "Hello", "world!") -> "Hello world!"
   + source/tools/Makefile
     source/tools/numtxthu.prg - NumToTxtHU() function to convert a
     number (especially currency) to a text. This is the Hungarian
     version. ( 115 -> "One hundred fifteen" )
     !! If you have such a function for your language, please add it, too.

19990731-02:30 EDT David G. Holm <dholm@jsd-llc.com>
   * source/hbpp/hbpplib.c
     ! ParseExpression() expects a null-terminated string.
     ! ParseExpression() returns the parsed input in the input
       string, not in the output string.

19990731-06:50 CET Victor Szel <info@szelvesz.hu>
   * include/extend.h
     include/hbdefs.h
     include/errorapi.h
     More small cleanups, additions.
   + include/clipdefs.h
     Added Clipper compatible header file. (not tested)
   + include/*.api - Added a file description line.
     Added a line which warns users not to use these
     files for new Harbour code.
   + include/caundoc.api - Contains undocumented API declarations
     (only wrappers as of now).
     Original idea by Bruno Cantero <bruno@issnet.net>.
   * include/rdd.api most of the content moved to include/rddapi.h
     source/rdd/dbfntx/dbfntx1.c
     source/rdd/dbcmd.c
     source/rdd/dbf1.c
     source/rdd/delim1.c
     source/rdd/sdf1.c
     *.api files are for compatibility only, not for
     new harbour code.
   + doc/hdr_tpl.txt - Small modification RCS ID and licenc part
     of the header separated.
   * include/*.* - Standardized (again) RCS ID and licenc headers.

19990731-06:40 GMT+2 Ryszard Glaaab <rglab@imid.med.pl>
    *source/compiler/harbour.y
        * PUBLIC and PRIVATE variables referenced inside a codeblock
         can be used to initialize a static variables

19990731-06:00 CET Victor Szel <info@szelvesz.hu>
   + include/achoice.ch
     include/common.ch
     include/dbstruct.ch
     include/directry.ch
     include/memoedit.ch
     include/dbedit.ch
     include/assert.ch
     include/getexit.ch
     include/simpleio.ch
     Missing Clipper compatible Harbour header files added.
   * source/rtl/extend.c -> Fixed memory management stuff
     moved to the new file source/rtl/fm.c
     source/rtl/Makefile
     makefile.*
   + source/rtl/fm.c
     include/fm.api
     include/extend.h
     _xalloc(), hb_xalloc() added for Clipper compatibility.
   + include/vm.api
     VM API added to provide some Clipper compatibility.
     VM functions are mapped to FM calls, Heap calls
     are accepted but functionality is not supported.
   * include/rdd.api
     include/error.ch
     include/inkey.ch
     include/color.ch
     include/fileio.ch
     include/rddsys.ch
     include/box.ch
     include/classes.ch
     include/set.ch
     Small cleanups. Missing #ifdef guards added.
   + make_tpl.sh - GNU Make launcher for bash/linux/gcc.

19990731-03:33 CET Victor Szel <info@szelvesz.hu>
   ! source/vm/hvm.c - Fixed some error codes.
     (.OR., .AND., PVALUE)
   * hb_ErrorNatDescription -> hb_errorNatDescription
     source/vm/hvm.c
     source/rtl/natmsg/*.c
     source/rtl/errorapi.c
     source/rtl/arrays.c
     include/errorapi.h
   + source/rtl/natmsg/*.c - Standardized, reformatted,
     ISO codes filled.
   + source/rtl/msgxxx.c
     source/rtl/natmsg/msghu852.c (former msghu.c)
     source/rtl/natmsg/msghucwi.c
     source/rtl/natmsg/msghuwin.c
     Support for two additional Hungarian codepages.
   % source/rtl/natmsg/*.c
     source/rtl/msgxxx.c
     hb_errorNatDescription() moved from natmsg/*.c to msgxxx.c
     so there's only one copy of it now.
   - source/rtl/natmsg/makefile.dos - Removed since it was not used at all.
   + doc/lang_id.txt - Standard RFC language code list.
   ! source/rtl/alert.prg - Some typo fixed.
   * source/rtl/runner/runner.c - #include <> -> #include ""

19990731-08:05 WIB Andi Jahja <andij@aonlippo.co.id>
   + source/rtl/menu.prg
     __AtPrompt()
     __MenuTo()
   + tests/working/testmenu.prg - Test Program

19990731-00:05 CET Victor Szel <info@szelvesz.hu>
   ! source/rtl/files.c - __CYGWIN__ defines changes rolled back,
     to fix the new DOS/DJGPP errors.
   + source/rtl/alert.prg - Made almost 100% Clipper compatible.
     - Parameter list is now compatible.
     - Placing of the box is now compatible.
     - Sizing of the box is now compatible.
     - Console mode added as in Clipper.
     - Color handling compatible.
     - Parameter error handling compatible. A Clipper bug fixed.
     - Hotkey support added as in Clipper.
     - Leaves the cursor where it was.
     - Optional support logic for undocumented //NOALERT switch.
     - Some small cleanups.

19990730-21:05 CET Victor Szel <info@szelvesz.hu>
   * source/rtl/files.c - Two __CYGWIN__ branches joined.

Fri Jul 30 14:44:00 1999  Gonzalo A. Diethelm  <Gonzalo.Diethelm@jda.cl>

        * config/bin.cf:
        * config/c.cf:
        * config/prg.cf:
        Added support for recursing into subdirectories in addition to
        creating a target (library or executable).
        Added support for executables whose main function is defined in a
        PRG file.

        * config/header.cf:
        Temporarily got rid of two definitions that look buggy.

        * include/run_exp.h:
        Got rid of warning regarding pragma.

        * source/hbpp/Makefile:
        * source/hbpp/hbppmain.c:
        * source/hbpp/stdalone/Makefile:
        * source/hbpp/stdalone/hbpp.c:
        Support for recursing into stdalone.
        Moved hbpp/hbppmain.c tp hbpp/stdalone/hbpp.c.

        * source/odbc/Makefile:
        * source/runner/Makefile:
        Added GNU-makefiles for these two directories (but they don'
        compile ok under gcc/Win32).

        * source/rtl/files.c:
        Changed defined(__GNUC__) for defined(__CYGWIN__).

        * source/rtl/gt/gtwin.c:
        Got rid of a warning.

19990730-20:24 CET Victor Szel <info@szelvesz.hu>
   - buildicc.cmd - Removed.
   - tests/working/list.txt - Removed, since it was
     suprseded by /funclist.txt

19990730-20:04 CET Victor Szel <info@szelvesz.hu>
   ! source/rtl/inkey.c
     source/rtl/files.c
     __CYGNUS__ -> __CYGWIN__
   ! tests/working/testpre.prg - Typo fixed.

19990730-14:00 EDT Paul Tucker <ptucker@sympatico.ca>
   * makefile.vc (reported by Matteo Baccan)
     + source/tools/fileread.prg
     + source/rtl/alert.prg

19990730-19:51 CET Victor Szel <info@szelvesz.hu>
   ! source/rtl/strings.c/HB_STRTRAN()
     Fixed so that it throws an error instead of
     returning "", when parameter 1 or 2 is of bad
     type.
   ! source/rtl/gtapi.c - Non-ANSI C compliant var
     declaration fixed.
     Posted by Dave Pearson <davep@hagbard.demon.co.uk>

19990730-12:30 EDT Paul Tucker <ptucker@sympatico.ca>
   * source/rtl/gt/gtwin.c
     * simplified gtputs and gtSetAttribute
     * corrected gtGetCursorStyle for !cci.bVisible return SC_NONE
       other cases should be handled by the switch that follows.
   * source/rtl/gt/gtdos.c source/rtl/gt/gtwin.c source/rtl/gt/gtos2.c
     ! renamed gtSetAttribute gtDrawShadow
       (currently active only in gtwin)
     + created new gtSetAttribute that will recolor a region.
       (currently not used)
   * source/rtl/gtapi.c
     * modified most internal calls to hb_gtMaxRow/Col to use Static vars.
     * gtScroll - fill scrolled region with spaces, not nulls
   * source/rtl/console.c
     * HB_SHADOW - call gtDrawShadow
     * HB_ISCOLOR now active when using gtdos
   * include/gtapi.h
     + added decl for gtDrawShadow

19990730-12:00 EDT Paul Tucker <ptucker@sympatico.ca>
   * makefile.vc
     + added inkey to harbour.lib
     * as submitted by Matteo Baccan
     + added missing dates2 to tools.lib
     * corrected output of dbfntx?.obj
   * source/rtl/dbfntx/dbfntx1.c
     * added typecast in getfunctable

19990730-15:33 CET Victor Szel <info@szelvesz.hu>
   + source/rtl/descend.c
     source/rtl/hardcr.c
     source/rtl/mtran.c
     Added documentation.
     Posted by Jose Lalin <dezac@corevia.com>

19990730-09:20 EDT Paul Tucker <ptucker@sympatico.ca>
   * makefile.vc
     + added sdf and delim support
     * changed natmsg\msgxxx to msgxxx
   * source/hbpp/hbpplib.c
     + added typecasts to 2 xgrab calls
   * source/rdd/dbcmd.c
     + added typecasts at line 337 but wrapped this one in an
       #if defined(_MSC_VER)

19990730-14:55 CET Victor Szel <info@szelvesz.hu>
   ! source/hbpp/preproc.c - defines _pFileName.
   ! source/hbpp/hbppmain.c - Definition of pFileName
     changed scope and name to _pFileName, so that
     OpenInclude() can use it. (not tested)
   ! source/rtl/alert.prg -
     Added left out original author info.
     Added missing #includes.
     Added RCS id.
   ! source/rtl/Makefile - Added alert.prg
   ! source/rdd/Makefile - Added new RDD stuff.
   ! source/hbpp/preproc.c/HB_PREPROCESS()
     Fixed unterminated result string problem.
     Fixed return value inconsistencies.
     Fixed to not use internals.
     Code cleanup.
   + include/hbdefs.h - Added MIN() and MAX() macros.
   * source/hbpp/harb.h - Removed.
   * source/hbpp/preproc.c renamed to hbpplib.c
     source/hbpp/Makefile
     (Please update other makefiles accordingly)
   * include/hbpp.h
     source/hbpp/hbpp.c
     source/hbpp/hbppint.c
     source/hbpp/hbpplib.c
     source/hbpp/hbppmain.c
     source/compiler/harbour.y
     Common declarations moved to one place, hbpp.h
   * source/hbpp/hbpp.c
     isname() -> ISNAME()
   * tests/working/testpre.prg - Small cleanup.

19990730-08:50 EDT Paul Tucker <ptucker@sympatico.ca>
   * makefile.vc
     * added dbfntx support (not nulsys yet)

19990730-12:46 GMT+1 Bruno Cantero <bruno@issnet.net>
   * tests/working/testrdd.prg
     Fixed a bug

19990730-12:24 GMT+1 Bruno Cantero <bruno@issnet.net>
   + source/rdd/sdf0.prg, source/rdd/sdf1.c, source/rdd/delim0.prg and source/rdd/delim1.c
     Support for two RDD's (SDF and DELIM)
   * include/rdd.api, source/rdd/dbcmd.c, source/rdd/dbf0.prg, source/rdd/dbf1.c
     Changed for support the new RDD's
   * tests/working/testrdd.prg
     Test for all RDD's in one PRG
   - include/rdd_api.old
     Removed old backup file

19990730-11:05 GMT+1 Antonio Linares <alinares@fivetech.com>
   * include/inkey.ch
     + More defines added

19990730-10:21 GMT+1 Antonio Linares <alinares@fivetech.com>
   * buildrdd.bat
     * removed PRGs building from there
   * rdd.b32
     * Added PRGs building
   * makefile.b32
     * Added Alert.prg building (note: I have not updated all makefiles!)
   * source/compiler/harbour.y
     * Added support for a:b[ c ]:d = e statements
   + source/rtl/alert.prg
   * tests/working/classch.prg
     * added Super:New() test
   + tests/working/debugger.prg

19990730-05:55 CET Victor Szel <info@szelvesz.hu>
   + source/hbpp/hbppint.c - Added "Warning" to the
     message "non directive in include file"
   + tests/broken/vec2.prg - Added a failing command:
     STATIC bBlock2 := {|| cMyPubVar }

19990730-05:00 CET Victor Szel <info@szelvesz.hu>
   ! source/rtl/inkey.c -
     #elif defined(__GNUC__) -> #elif defined(__CYGNUS__)
   ! source/hbpp/preproc.c - MakeFilename() bug fixed here, too.
     It's quite strange that we have three copies of MakeFilename()
     in various source files.
   + source/hbpp/hbppint.c - Added hbpp_init() prototype.
   ! source/hbpp/hbpp.c - Fix: #include directive will search for
     the header file in the directory of the compiled .PRG file,
     not in the current directory as before.
   + source/hbpp/hbpp.c - Added support for
     #include 'x' and #include <x>, the latter searches only in
     the include directories, like in C.
   ! source/hbpp/hbpp.c - Added patch to fix the GPF in RTL_TEST
     when using Win32/GCC (and some others).
     Posted by Dave Pearson <davep@hagbard.demon.co.uk>

19990729-22:00 EDT Paul Tucker <ptucker@sympatico.ca>
   * source/rtl/inkey.c
      + added comments and example for implimenting ReleaseCPU

19990729-22:00 EDT Paul Tucker <ptucker@sympatico.ca>
   * source/rtl/console.c
      * HB_SHADOW/DBGSHADOW
        5th param is optinal and defaults to 7  (w/n)

19990729-19:40 EDT Paul Tucker <ptucker@sympatico.ca>
   * source/rtl/console.c
     source/rtl/gtapi.c
     source/rtl/gt/gtwin.c
     source/rtl/gt/gtdos.c
     source/rtl/gt/gtos2.c
       * Adjusted a number of functions to accept coordinates in Row, Col
         order - some of them were reversed.
   ! source/rtl/gt/gt*.c
       renamed gtwhereX gtwhereY and gtGotoXY to
       gtCol, gtRow and gtSetPos
   * include/gtapi.h
       adjusted gt decls to account for above changes

19990729-23:35 CET Victor Szel <info@szelvesz.hu>
   ! source/rtl/objfunc.prg - Typo fixed.
     "doesnt exists in class" -> "does not exist in class"

19990729-23:00 GMT+1 Bruno Cantero <bruno@issnet.net>
   * makefile.env, makefile.dos,source/makefile.dos, source/rdd/makefile.dos
   + source/rdd/dbfntx/makefile.dos
     Full support RDD for DJGPP

Thu Jul 29 16:17:09 1999  Gonzalo A. Diethelm  <Gonzalo.Diethelm@jda.cl>

        * config/dos/djgpp.cf:
        * config/linux/gcc.cf:
        * config/os2/gcc.cf:
        * config/win32/gcc.cf:
        * config/win32/msvc.cf:
        One more modification: the DB drivers must be linked against only
        when the Makefile specifies linking against the rdd
        library. Otherwise, other binaries such as the Harbour compiler
        would try to link against the DB drivers.

Thu Jul 29 15:58:44 1999  Gonzalo A. Diethelm  <Gonzalo.Diethelm@jda.cl>

        * source/rdd/Makefile:
        * source/rdd/nulsys/Makefile:
        Bruno Cantero pointed out that a user may use all of the DB
        drivers simultaneously, so I got rid of the environment variable
        and made sure all of the valid DB drivers are linked against the
        application. On of the valid drivers is nulsys.

        * config/global.cf:
        Now a list of all the valid DB drivers is stored in
        HB_DB_DRIVERS.

        * config/dos/djgpp.cf:
        * config/linux/gcc.cf:
        * config/os2/gcc.cf:
        * config/win32/gcc.cf:
        * config/win32/msvc.cf:
        Deleted support for environment variable HB_DB_DRIVER.
        Added support for make variable HB_DB_DRIVERS.

Thu Jul 29 14:46:51 1999  Gonzalo A. Diethelm  <Gonzalo.Diethelm@jda.cl>

        * source/rdd/Makefile:
        * source/rdd/dbfntx/Makefile:
        Now there is a subdirectory for each database driver. For now,
        only dbfntx/ is supported. The Makefile in rdd/ walks into each
        subdirectory.

        * source/rdd/dbfntx0.prg:
        * source/rdd/dbfntx1.c:
        * source/rdd/dbfntx/dbfntx0.prg:
        * source/rdd/dbfntx/dbfntx1.c:
        Moved these files from rdd/ to rdd/dbfntx/.

        * config/bin.cf:
        * config/dir.cf:
        * config/header.cf:
        * config/lib.cf:
        * config/test.cf:
        * config/dos/djgpp.cf:
        * config/linux/gcc.cf:
        * config/os2/gcc.cf:
        * config/win32/gcc.cf:
        * config/win32/msvc.cf:
        Added support for the new separate directories for the database
        driver. The user must define an environment variable HB_DB_DRIVER
        with the appropriate driver he wants to use. For example, defining
        it to 'dbfntx' will pick up that driver.

19990729-18:39 CET Victor Szel <info@szelvesz.hu>
  - source/rdd/dbcmd.c
    now redundant declarations removed. (again)
  + source/rdd/Makefile - new files added.

19990729-18:51 GMT+1 Bruno Cantero <bruno@issnet.net>
   + source/rtl/natmsg/msgspa.c
     Changed any messages.

19990729-19:38 GMT+1 Antonio Linares <alinares@fivetech.com>
   * source/rtl/console.c
      * several fixes at SAVESCREEN, RESTSCREEN and SETCURSOR

19990729-18:50 GMT+1 Bruno Cantero <bruno@issnet.net>
   + source/rdd/dbf0.prg, source/rdd/dbf1.c
     Added RDD DBF
   * source/rdd/rddsys.prg
     Prepared for use ANNOUNCE/REQUEST keywords
   * source/rdd/dbcmd.c
     Added more functions and now the RDD system is a tree of RDD's
   * tests/working/testrdd.prg
     Changed for test two RDD's
   * makedos.env
     Added DBFNTXLIB=$(HARBOURDIR)/libs/libdbfntx.a
   * source/rdd/makefile.dos
     Changed to create $(HARBOURLIB) and $(DBFNTXLIB)
     dbcmd.o, rddsys.o, dbf0.o and dbf1.o now in lharblib.a
     dbfntx0.o and dbfntx1.o now in ldbfntxlib.a
   * tests/working/makefile.dos
     Added ldbfntxlib.a to link

19990729-18:40 GMT+1 Bruno Cantero <bruno@issnet.net>
   * source/vm/hvm.c
     Remove all RDD references. Now it isn't necesary.

19990729-11:35 EDT Paul Tucker <ptucker@sympatico.ca>
   * source/rtl/console.c
     * hb_setCursor - account for optional param. #ifdef .. GTAPI
     * hb_Save/RestScreen #ifdef .. GTAPI
       * account for nil params ie: SaveScreen(,,,,@Buf)
       * use hb_gtRectSize

19990729-13:26 GMT+1 Antonio Linares <alinares@fivetech.com>
   * source/rtl/gt/gtwin.c
      * Fixed gtGetCursorStyle when cci.bVisible returning SC_NORMAL
   * source/rtl/console.c
      * high level C source code implemented for SAVESCREEN, RESTSCREEN anb SETCURSOR

19990729-12:13 CET Victor Szel <info@szelvesz.hu>
  + include/extend.h -
    hb_strLower(), hb_strUpper() declarations added.
    extern STACK stack; added
    extern SYMBOL symEval; added
    extern HB_ITEM errorBlock; added
    extern HB_ITEM aStatics; added
  - source/rdd/dbcmd.c
    source/rtl/setcolor.c
    now redundant hb_strUpper() declarations removed.
  - source/rtl/transfrm.c
    source/rtl/classes.c
    source/rtl/arrays.c
    source/rtl/math.c
    source/rtl/itemapi.c
    source/rtl/extend.c
    source/rtl/dir.c
    source/rtl/descend.c
    source/rtl/dates.c
    source/rtl/codebloc.c
    source/rtl/errorapi.c
    source/rdd/dbcmd.c
    source/hbpp/preproc.c
    source/tools/debug.c
    Removed explicit references to above added externs.
  + include/dates.h -
    extern char *hb_monthsname[]; added
    extern char *hb_daysname[]; added
  - source/rtl/dates.c
    source/tools/dates2.c
    Removed explicit references to above added externs.
  - source/rtl/classes.c - Removed reference to DoBlock()
  - source/rtl/codebloc.c - Redefinition of TRUE/FALSE removed.
  + source/rtl/dir.c - Copyright statement added for
    hb_strMatchDOS() function.

19990729-11:20 CET Victor Szel <info@szelvesz.hu>
  ! tests/working/rtl_test.prg - Now returns errorlevel 1
    if anything fails, and 0 if OK. Now for sure.
  * source/vm/hvm.c - Get rid of a few low level ITEM access.

19990729-10:40 CET Victor Szel <info@szelvesz.hu>
  ! source/vm/hvm.c - #include "itemapi.h" added
    to fix a warning.
  ! source/rtl/inkey.c - hb_inkeyPoll() #define-ed out
    the kbhit() and getch() calls in Cygwin, until
    some better solution is found.
  + include/ctoharb.h - PushNumber() declaration added.
  + source/rtl/arrays.c/hb_arrayEval() now passes the index
    to the codeblock as the second parameter.
  + tests/working/arreval.prg
    tests/working/Makefile
    aEval() test program added.
  - source/rtl/arrays.c - Removed duplicate declarations.
  + tests/working/rtl_test.prg - Now returns errorlevel 1
    if anything fails, and 0 if OK.

19990729-01:40 EDT Paul Tucker <ptucker@sympatico.ca>
   * source/rtl/dir.c
     + #if !defined(FA_ENCRYPTED)
   * source/compiler/harbour.y
     * in FUNCINFO[] change:
     { SELECT, 0, 1 }

19990729-05:25 CET Victor Szel <info@szelvesz.hu>
  * Changed all #include <x> to #include "x", where
    x is a Harbour header file.
    Many source and header files involved.
  * include/extend.h - Small cleanups.
  * include/extend.h - Some functions renamed to be more
    consistent.
    source/rtl/arrays.c
    source/rtl/classes.c
    source/rtl/codebloc.c
    source/rtl/dir.c
    source/rtl/errorapi.c
    source/rtl/extend.c
    source/rtl/itemapi.c
    source/rtl/memvars.c
    source/rtl/transfrm.c
    source/tools/debug.c
    source/vm/hvm.c
    ItemCopy()      -> hb_itemCopy()
    ItemRelease()   -> hb_itemClear()
    ItemUnRef()     -> hb_itemUnRef()
    GetMethod()     -> hb_GetMethod()
  * include/version.h renamed to hb_ver.h
    source/rtl/environ.c
    source/compiler/harbour.y
    include/Makefile
  * source/vm/hvm.c - hb_item*() functions moved to source/rtl/itemapi.c
  * source/vm/hvm.c - Codeblock and memvar management function
    declarations moved to include/extend.h
  * source/rtl/strcmp.c/hb_stricmp() moved to source/rtl/strings.c
  * source/rtl/strcmp.c/hb_itemStrCmp() moved to source/rtl/itemapi.c
  - source/rtl/strcmp.c removed.
    source/rtl/makefile
    makefile.b16
    makefile.b31
    makefile.b32
    makefile.b40
    makefile.vc
  - makefile.icc removed (superseded by GNU Make System)
  + tests/working/rtl_test.prg - Further improved, it's
    now fully automatic.
  ! source/rtl/strings.c - LEFT(),RIGHT(),SUBSTR() bugs fixed with
    some LONG casts for asstring.length.
    UPPER(),LOWER() LONG -> ULONG
  * source/compiler/harbour.y
    source/compiler/harbour.l
    source/compiler/genobj32.c
    Some ints changed to BOOL.
  ! tests/working/strsub.prg - "Press a key" changed
    to "press Enter".

19990728-19:45 GMT+1 Antonio Linares <alinares@fivetech.com>
   * include/classes.ch
     Added support for 'Super' keyword

19990728-19:35 CET Patrick Mast <harbour@PatrickMast.com> <jsalas@gruposp.com>
  + /harbour/contrib/directX
    Added Jesus'es DirectX files.

Wed Jul 28 11:54:06 1999  Gonzalo A. Diethelm  <Gonzalo.Diethelm@jda.cl>

        * source/rtl/dir.c:
        Fixed a typo: #if define(USE_NT) => #if defined(USE_NT).

        * source/rtl/inkey.c:
        Added an include of <mingw32/conio.h> when compiling with gcc.

        * include/Makefile:
        * tests/working/Makefile:
        Updated list of files.

19990728-14:30 CET Eddie Runia <eddie@runia.com>
  * source/rtl/dir.c
    #include <errno.h> added

19990728-14:15 CET Eddie Runia <eddie@runia.com>
  * source/rtl/dir.c
    FA_ENCRYPTED etc. only available if USE_NT has been defined

19990728-13:10 CET Victor Szel <info@szelvesz.hu>
  ! source/hbpp/hbppmain.c - MakeFilename() bug fixed here, too.
    (see 19990728-05:40)
  ! source/hbpp/harb.h - Include Harbour header files, instead of
    repeating part of their content explicitly. Some warnings
    about re-#defines fixed.
  ! source/hbpp/preproc.c - #pragma Preprocess__InitSymbols
    excluded when __GNUC__. So no more compiler warning with Win32/GCC.

19990728-13:13 GMT+1 Bruno Cantero <bruno@issnet.net>
   * source/rdd/rddsys.prg, source/rdd/dbcmd.c, source/rdd/dbfntx0.prg
     source/rdd/dbfntx1.c, include/rdd.api, tests/working/testrdd.prg
     The size of WorkAreas now is variable
     Testing under MSVC++ 6.0 and DJGPP

19990728-14:44 Alexander Kresin
  * source\hbpp\hbpp.c
    * Bug, appeared after last change, fixed

19990728-12:30 CET Eddie Runia <eddie@runia.com>
  * source/runner/runner.c
     Symbols with both INIT and EXIT raised are not EXIT symbols.
  * include/extend.h
     FS_INITEXIT added as a mask to check the above

19990728-11:31 Alexander Kresin
  * source\hbpp\hbpp.c
    * Yet another problem fixed with rtl_test and C++ Builder

19990728-10:22 Alexander Kresin
  * source\hbpp\hbpp.c
  * source\hbpp\hbppint.c
  * source\hbpp\hbppmain.c
  * source\hbpp\table.c
  * include\hbpp.h
    * Bug fixed for rtl_class.prg ( mentioned by Victor Szel )
    * Linked list for defines instead or array

19990728-01:10 EDT Paul Tucker <ptucker@sympatico.ca>
   * source/rtl/gtapi.c
     * minor correction in case of inverted coordinates

19990728-05:40 CET Victor Szel <info@szelvesz.hu>
   ! source/compiler/harbour.y/MakeFilename() -
     Fixed bug, which sometimes caused that the
     filename losed the "." extension separator char.
   ! tests/working/makefile - newcopy.prg removed.
   + tests/working/strsub.prg - Added some more tests, and the
     expected results.
   ! source/vm/hvm.c - Minus() simplified and fixed for strings.
   ! config/dos/djgpp.cf - Added -g to CFLAGS, so it's
     able to make test programs.

19990728-03:50 CET Victor Szel <info@szelvesz.hu>
   ! config/win32/msvc.cf - Missing include added.

19990727-16:30 EDT David G. Holm <dholm@jsd-llc.com>
  * source/rtl/dir.c
    + Added support for IBM Visual Age C++ compiler
  * source/rtl/gt/gtos2.c
    ! Corrected function declration for gtSetAttribute()
  * tests/working/dirtest.prg
    * Changed QOUT() to OUTSTD() to allow the directory listing to be
      redirected, regardless of whether or not the GT API is linked in

19990727-22:20 CET Victor Szel <info@szelvesz.hu>
   + tests/broken/lnlenli1.prg
   + tests/broken/lnlenli2.prg
     Test programs added to test how Harbour handles extremly long lines.
   ! tests/broken/vec2.prg
     Added RCS line.

19990727-21:00 CET Victor Szel <info@szelvesz.hu>
   + source/compiler/harbour.y - Help screen updated.
     /a,/v added /t deleted, made it even more Clipper like.
     original Clipper typo "supress" fixed.

19990727-20:15 GMT+2 Ryszard Glab <rglab@imid.med.pl>

    *source/compiler/harbour.y
         * static variables can be initialized using the codeblocks
          that calls functions. However static variables still cannot
          be initialized with direct function call.
         * changed the symbol created for function that initialize
          static variable to: '(_INITSTATICS)' and generated function is
          named now hb_INITSTATICS - this allows to create an user
          defined function or memvar named _INITSTATICS
         * the _INITSTATICS function (used to initialize static variables)
          have the scope equal to (FS_INIT | FS_EXIT) - to distinguish
          this function from other INIT functions. All _INITSTATICS
          functions defined in the application have to be called
          before normal INIT functions are called.

    *source/vm/hvm.c
         * All _INITSTATICS functions defined in the application are
          called before normal INIT procedures - this allows to use
          static variables in INIT procedures

    *tests/working/initexit.prg
         * updated code to test cooperation of INIT procedures with
          static variables

    *include/rdd.api
         + added forward declaration for struct _RDDFUNCS

    *source/rtl/natmsg/msgbas.c
    *source/rtl/natmsg/msgcat.c
    *source/rtl/natmsg/msgcz852.c
    *source/rtl/natmsg/msgczkam.c
    *source/rtl/natmsg/msgdut.c
    *source/rtl/natmsg/msgeo.c
    *source/rtl/natmsg/msgfre.c
    *source/rtl/natmsg/msggal.c
    *source/rtl/natmsg/msgger.c
    *source/rtl/natmsg/msghu.c
    *source/rtl/natmsg/msgia.c
    *source/rtl/natmsg/msgita.c
    *source/rtl/natmsg/msgkor.c
    *source/rtl/natmsg/msgpl852.c
    *source/rtl/natmsg/msgplmaz.c
    *source/rtl/natmsg/msgpor.c
    *source/rtl/natmsg/msgr1251.c
    *source/rtl/natmsg/msgru866.c
    *source/rtl/natmsg/msgspa.c
    *source/rtl/natmsg/msguk.c
    *source/rtl/natmsg/msgyu852.c
        * corrected bug in hb_ErrorNetDescription
        (was "<=" instead of "<" ;-)

19990727-19:48 GMT+1 Bruno Cantero <bruno@issnet.net>
   * source/rdd/dbcmd.c
     Fixed a GFP (Paul, test it)

19990727-19:18 GMT+1 Bruno Cantero <bruno@issnet.net>
   * source/rdd/dbfntx1.c
     Fixed a bug

19990727-19:08 GMT+1 Bruno Cantero <bruno@issnet.net>
   * source/rtl/natmsg/*.c
     Added #include <hbdefs.h> to these files

19990727-12:35 EDT David G. Holm <dholm@jsd-llc.com>
  * source/rtl/dir.c
    ! Corrected two errors that the MSC changes introduced for non-MSC
      non-Unix compilers: 1) The intermediate long variable fsize is now
      back in place; 2) The use of 'attrib = entry.attrib;' is now #ifdefed
      for MSC and the use of 'attrib = _chmod(fullfile,0);' is restored for
      non-MSC non-Unix compilers.

19990727-13:45 GMT+1 Antonio Linares <alinares@fivetech.com>
   * include/classes.ch
     + added support for multiple classes definition on the same PRG

19990727-13:08 CET Victor Szel <info@szelvesz.hu>
   + tests/broken/vec2.prg - Added

19990727-14:21 Alexander Kresin
  * source\hbpp\hbpp.c
    * ParseExpression() rewritten for supporting new classes functionality

19990727-02:22 EDT Paul Tucker <ptucker@sympatico.ca>
   * include/gtapi.h
     + added definition of gtSetAttribute
   * source/rtl/dates.c
     * hb__seconds - fixed MSC support for correct hundreths.
   * source/rtl/dir.c
     * Directory() now works under msc.  Other platform users should
       review the code and add defined()'s or code as needed.
   * source/rtl/gt/gtwin.c
     + gtSetAttribute()
   * source/rtl/gt/gtdos.c source/rtl/gt/gtos2.c
     + Empty gtSetAttribute()
   * source/rtl/console.c
     + empty SAVESCREEN,RESTSCREEN
     + SHADOW() and DBGSHADOW() now implimented

19990727-07:50 CET Felipe Coury
   * tests/working/hscript/dir.hs; tests/working/hscript/hello.hs;
     tests/working/hscript/hscript.prg; tests/working/hscript/multiply.hs;
     tests/working/hscript/ugly.hs
     New version
   * tests/working/testcgi.prg
     New version as well

19990727-06:12 GMT+1 Antonio Linares <alinares@fivetech.com>
   * makefile.b32
     + Added inkey.c module

19990726-21:35 EDT David G. Holm <dholm@jsd-llc.com>
  * config/os2/dir.cf
    ! Corrected FOR statement to work properly when called from CMD.EXE
      which means that when using 4OS2, the GNU Make System must be run
      using: CMD /C make -r (or CMD /C make -r clean)
  * config/os2/install.cf
    ! Corrected FOR statement to work properly when called from CMD.EXE
      which means that when using 4OS2, the GNU Make System must be run
      using: CMD /C make -r install
  * include/inkey.ch
    + Added INKEY_EXTENDED event mask code
    + Added mouse event codes
  + include/inkey.h
    + New support module for new module source/rtl/inkey.c
  * include/set.h
    + Added INKEY_EXTENDED
    + Added version comment for V 1.17 by Bruno Cantero
    * Corrected version number in version history for V 1.16
  * source/hbpp/Makefile
    ! Added preproc.c, so that tests/working/testpre.prg will link
  * source/rtl/Makefile
    * Added inkey.c
  * source/rtl/dates.c
    + Added _MSC_VER to list of compilers that use DOS method to get
      seconds and fractions in SECONDS() instead of just whole seconds
  * source/rtl/files.c
    * hb_fopen() now generates runtime error BASE/2021 when filename
      parameter is not a string (argument error)
  + source/rtl/inkey.c
    + New module for CLEAR TYPEAHEAD, INKEY(), KEYBOARD, NEXTKEY(),
      LASTKEY() and SET TYPEAHEAD support (no mouse support yet)
  * source/rtl/math.c
    ! MIN() and MAX() no longer generate an argument error when called
      with different numeric types
    ! MIN() and MAX() now return the first parameter when both are equal
  * source/rtl/set.c
    * Modified HB_SET_TYPEAHEAD handling to use INKEY() support function
      hb_inkeyReset() to adjust the size of the keyboard typeahead buffer
    ! Corrected HB_SET_TYPEAHEAD handling to use set_number()
  * source/tools/Makefile
    + Added fileread.prg
  + source/tools/fileread.prg
    + New file reader class reads files one line at a time
  * source/vm/hvm.c
    + Added call to hb_inkeyPoll() at top of Virtual Machine loop
  * tests/working/Makefile
    + Added inkeytst.prg
    + Added readfile.prg
  + tests/working/inkeytst.prg
    + Test program for INKEY(), NEXTKEY(), LASTKEY(), KEYBOARD,
      SET TYPEAHEAD, and CLEAR TYPEAHEAD.
  * tests/working/mathtest.prg
    + Added MIN() and MAX() tests
  + tests/working/readfile.prg
    + Test program for new file reader class (the test program dumps the
      file contents to STDOUT to let you redirect to file so that you can
      compare the input and output files)
  * tests/working/seconds.prg
    * If run with a number as a command line parameter, the loop will be
      executed that many times, without pausing between calls to SECONDS()

19990726-22:35 CET Patrick Mast <harbour@PatrickMast.com>
   + Build40.bat and Makefile.b40
     Build and makefile for Borland 4.0

19990726-03:25 EDT Paul Tucker <ptucker@sympatico.ca>
   * source/rtl/dbcmd.c
     + memset(pWorkAreas,0,sizeof(AREA)); in rddInit
     * a couple more (or maybe the same) casts to help msvc.

19990726-20:52 CET Victor Szel <info@szelvesz.hu>
   * tests/working/rtl_test.prg - make use of the preproc
     and thus it's more easy to expand it, and fewer human
     errors can be made. We could use this idea in several
     other test programs, too.
   ! tests/working/transfrm.prg - Buggy test line fixed.

19990726-20:32 GMT+1 Bruno Cantero <bruno@issnet.net>
   * source/rdd/dbfntx1.c
     Fixed bug under msvc

19990726-20:20 CET Eddie Runia <eddie@runia.com>
  * tests/working/hscript/bldguest.bat
    Better version added. (Old version was meant for working directory)

19990726-20:59 Alexander Kresin
  * source\hbpp\hbpp.c
    * Fixed some bugs with quotes, '??'
  * source\hbpp\hbppint.c
  * source\hbpp\hbppmain.c
    * some functions prefixed with pp_

19990726-18:24 GMT+1 Bruno Cantero <bruno@issnet.net>
   * include/rdd.api, source/rdd/dbcmd.c, source/rdd/dbfntx1.c and tests/working/testrdd.prg
     Added more RDD functions
     Implemented dynamic WorkAreas

19990726-18:12 GMT+1 Bruno Cantero <bruno@issnet.net>
   * makefile.dos, source/makefile.dos and source/rdd/makefile.dos
     Added RDD support

Mon Jul 26 11:42:11 1999  Gonzalo A. Diethelm  <Gonzalo.Diethelm@jda.cl>

        * include/Makefile:
        * source/rdd/Makefile:
        * tests/working/Makefile:
        Updated file lists.

19990726-13:20 CET Victor Szel <info@szelvesz.hu>
   + source/rtl/gtapi.c
     Some minor fixes and corrections mainly to gtBox()

19990726-12:50 CET Victor Szel <info@szelvesz.hu>
   + source/rtl/natmsg/msghu.c
     Error descriptions translated.

19990726-06:05 EDT Paul Tucker <ptucker@sympatico.ca>
   * source/rtl/gtapi.c
     * position cursor inside top-left corner of box - compatibility
   * source/rtl/console.c
     * Row() and Col() - too passive when linked with gtapi.

19990726-05:20 EDT Paul Tucker <ptucker@sympatico.ca>
   * source/rtl/gtapi.c
     * much improved box drawing speed.
   * source/rtl/msgita.c from Matteo Baccan
   * source/rtl/msgpor.c from Felipe Coury

19990725-09:50 CET Felipe Coury
   + tests/working/hscript/guestbk.ini; tests/working/hscript/guestbk.htm;
     tests/working/hscript/guestbk.prg; tests/working/hscript/guestbk.txt;
     tests/working/hscript/bldguest.bat;
     Harbour guestbook added

19990725-09:45 CET Eddie Runia <eddie@runia.com>
   * source/runner/runner.c
     GPL text added

19990726-09:45 Antonio Linares <alinares@fivetech.com>
   * source/rtl/natmsg/msguk.c
      * missing #include <hbdefs.h>

19990726-01:06 EDT Paul Tucker <ptucker@sympatico.ca>
   * makefile.vc
     * changed msguk to msgxxx
   * source/rdd/dbfntx1.c
     * corrected assignement of RDDFUNCSCOUNT now that I see what it's doing

19990726-00:20 EDT Paul Tucker (from Felipe Coury) <ptucker@sympatico.ca>
   * rdd.b32
   * buildrdd.bat
   * tests/working/bld32w.bat
     + added support for new files in rdd

19990726-02:30 GMT+2 Ryszard Glab <rglab@imid.med.pl>

        *include/errorapi.h
         + added declaration of hb_ErrorNatDescription() function -this
          function should be used to read a description of generic errors

        *source/rtl/errorapi.c
         * changed to read a generic error description form national
          language module:
          hb_errorRT_BASE(), hb_errorRT_TERMINAL(), hb_errorRT_DBCM() calls
          hb_ErrorNatDescription() when there is no description specified
          in function that generates an error

        *include/error.ch
         * new generic error codes:
                EG_ARGCOUNT     Incorrect number of arguments
                EG_ARRACCESS    array access
                EG_ARRASSIGN    array assign
                EG_NOTARRAY     not an array
                EG_CONDITION    conditional

        *source/rtl/natmsg/msgbas.c
        *source/rtl/natmsg/msgcat.c
        *source/rtl/natmsg/msgcz852.c
        *source/rtl/natmsg/msgczkam.c
        *source/rtl/natmsg/msgdut.c
        *source/rtl/natmsg/msgeo.c
        *source/rtl/natmsg/msgfre.c
        *source/rtl/natmsg/msggal.c
        *source/rtl/natmsg/msgger.c
        *source/rtl/natmsg/msghu.c
        *source/rtl/natmsg/msgia.c
        *source/rtl/natmsg/msgita.c
        *source/rtl/natmsg/msgkor.c
        *source/rtl/natmsg/msgpl852.c
        *source/rtl/natmsg/msgplmaz.c
        *source/rtl/natmsg/msgpor.c
        *source/rtl/natmsg/msgr1251.c
        *source/rtl/natmsg/msgru866.c
        *source/rtl/natmsg/msgspa.c
        *source/rtl/natmsg/msguk.c
        *source/rtl/natmsg/msgyu852.c
         + the table with generic errors' descriptions was added
         + new hb_ErrorNatDescription() that returns error description

        *source/rtl/natmsg/msgpliso.c
         + new module for Polish ISO-8859-2 coding

        *source/rtl/arrays.c
        *source/rtl/copyfile.c
        *source/rtl/classes.c
        *source/rtl/dates.c
        *source/rtl/math.c
        *source/rtl/set.c
        *source/rtl/strings.c
        *source/rtl/transfrm.c
        *source/rtl/memvar.c
        *source/rtl/rdd/dbcmd.c
        *source/tools/dates2.c
        *source/vm/hvm.c
         * changed to use generic error codes (EG_*) instead of hard-coded
          descriptions

        *source/rdd/Makefile
         *corrected to compile files placed in this directory

        *tests/working/Makefile
         + added rdd library

        *source/rtl/gtxxx.c
         + added #include "hbsetup.h" to properly include platform specific
          files based on settings in hbsetup.h

        *source/rtl/msgxxx.c
         + added #include "hbsetup.h" to properly include platform specific
          files based on settings in hbsetup.h
         +added #include "hbdefs.h"

        *source/compiler/harbour.y
         + added support for '-a' automatic MEMVAR declaration
         * extended support for MEMVAR declaration
         + added definition of VS_PRIVATE and VS_PUBLIC

        *include/hberror.h
         + new warning code WARN_MEMVAR_ASSUMED

        *include/extend.h
         - removed definition of VS_PRIVATE and VS_PUBLIC

        *source/rtl/memvars.c
         + added definition of VS_PRIVATE and VS_PUBLIC

        *source/hbpp/table.c
         * changed names for memvar related functions ('__MV' prefix)
          in RELEASE, CLEAR* and SAVE/RESTORE commands

19990725-23:12 CET Victor Szel <info@szelvesz.hu>
   + make_tpl.bat
     Template batch file to call the GNU make system.

19990724-21:20 EDT Paul Tucker <ptucker@sympatico.ca>
   * source/rdd/dbcmd.c
     * added type casts mostly on xgrab calls
   * source/rdd/dbfntx0.c
     * commented out 1 assignment, as uiCount
       is not pointing at anything.
   * makefile.vc
     + added additional rdd support

19990725-19:47 GMT+1 Bruno Cantero <bruno@issnet.net>
   + include/rddsys.ch, source/rdd/dbfntx0.prg, source/rdd/dbfntx1.c
     Skeleton for DBFNTX functions
   + tests/working/testrdd.prg
     Test for RDD functions
   * source/rdd/dbcmd.c
     Bug fixed
   * source/rdd/rddsys.prg
     Register the default driver (DNFNTX)
   * include/rdd.api, include/rdd_api.old
     File renamed

19990724-21:20 EDT Paul Tucker <ptucker@sympatico.ca>
   * makefile.vc
   * tests/working/buildvc.bat
     + added support for the rdd.

19990725-01:00 GMT+2 Ryszard Glab <rglab@imid.med.pl>

        *source/rtl/memvars.c
         * corrected code that handle values' cache
         + added code to test variables with the names that are the same
          as functions names
         * variables passed by reference are correctly handled now in
          PARAMETERS statement
         * renamed __PUBLIC to __MVPUBLIC and __PRIVATE to __MVPRIVATE
          all other functions related to memory variables will start
          with '__MV' prefix
         + added __MVXRELEASE function to release value stored in memvar
          variable (it can be used in RELEASE command)

        *source/vm/hvm.c
         * variables passed by reference are correctly handled now in
          PARAMETERS statement

        *source/compiler/harbour.y
         * the symbol table is generated correctly now if a memvar variable
           have the same name as one of used functions or is the same as the
           name of compiled module
         * simplified and cleared handling of symbol positions

        *source/compiler/harbour.l
         * MEMVAR keyword is handled correctly now

        *tests/working/memvar.prg
         + added code to test variables with the names that are the same
          as functions names

19990725-00:20 CET Felipe Coury
   * tests/working/bld32exe.bat
     changed for RDD
   + buildrdd.bat; rdd.b32
     makefiles for RDD
   * build32.bat
     changed for RDD

19990724-21:02 GMT+1 Bruno Cantero <bruno@issnet.net>
   + include/set.h
     Added two prototypes
   + source/vm/hvm.c
     Added one prototype and initialize the RDD
   + include/errorapi.h
     Added one prototype
   + source/rtl/errorapi.c
     New function: hb_errorRT_DBCMD
   + source/rdd/dbcmd.c
     New file. First functions for the RDD system
   + source/rdd/rddsys.prg
     New file. Define the default RDD driver (DBFNTX)
   * source/rdd/nulsys/nulsys.prg
     New file. Allow compile without RDD driver

19990727-21:11 CET Patrick Mast <harbour@PatrickMast.com>
  * Release of Build 29

19990724-11:50 CET Patrick Mast <harbour@PatrickMast.com>
  * Makefile.b16 and Makefile.b32
    added -DHARBOUR_USE_GTAPI swicth

19990723-06:39 EDT Paul Tucker <ptucker@sympatico.ca>
   * source/rtl/gtapi.c
   * source/rtl/setcolor.c
     * modified some if statements to specifically test for != 0

19990723-06:39 EDT Paul Tucker <ptucker@sympatico.ca>
   * source/rtl/devoutp.prg
     * second param to devout() is color, not picture

19990723-06:39 EDT Paul Tucker <ptucker@sympatico.ca>
   * source/rtl/transfrm.c
     * changed GetDynSym to hb_GetDynSym (again)

19990723-12:07 Antonio Linares <alinares@fivetech.com>
   * terminal.b32
     * Fixed for Win32 console mode Harbour apps
   * makefile.b32
     * Support for C debugger
   * tests/working/bld32exe.bat
     * Support for C debugger

19990723-12:00 CET Eddie Runia <eddie@runia.com>
  * source/rtl/transfrm.c
    Decimals and width from parameter used if no template specification
    is present
  + tests/working/transdef.prg
    Test program used

19990723-07:45 CET Matthew Hamilton
  * tests/working/inifiles.prg
    Even newer version

19990723-02:45 GMT+2 Ryszard Glab <rglab@imid.med.pl>

        *source/compiler/harbour.y
         * corrected generation of symbols for memvar variables
         * PARAMETERS are handled now in the same way as in Clipper
          (if PARAMETERS statement is repeated in the same function then
          the first parameter listed is always equal to the first argument,
          the second parameter is initialized with the second argumennt etc)

        *source/rtl/memvars.c
         * reference to variables are correctly updated
         * item returned from hb_arrayGet() is of  proper type now and
          is properly released

        *source/rtl/codebloc.c
         * changed to use second parameter of hb_MemvarValueNew()

        *source/vm/dynsym.c
         * symbols created dynamically are properly released now
          (SYM_ALLOCATED is now type casted to new type SYMBOLSCOPE - the
          scope value (char) was compared with (int) previously and it was
          never true (char was extended to int -1)

        *include/hbdefs.h
         + added new SYMBOLSCOPE typedef

        *include/extend.h
         * changed to support new SYMBOLSCOPE typedef
         * replaced void *pDynSym with struct _DYNSYM *pDynSym

        *tests/working/memvars.c
         + added noew code to test memvars
         * it shouldn't report the unreleased memory blocks now

19990722-10:50 EDT Paul Tucker <ptucker@sympatico.ca>
    *source/rtl/dir.c
       * corrected hang when passing a second param to dirtest.

19990722-16:30 GMT+2 Ryszard Glab <rglab@imid.med.pl>

    *source/compiler/harbour.y
        * symbol names are no longer released for the second time
         (it caused that DJGPP hanged in 'free' function)

    *source/hbpp/makefile
        + added preproc.c

    *source/hbpp/harb.h
        - changed to definie LONG and ULONG typedefs if there is no
         HB_DEFS_H_ defined (these typedefs are defined in hbdefs.h)

    *source/hbpp/preproc.c
        - removed nested /* */

    *tests/working/Makefile
        - removed statics1.prg and statics2.prg because these file have to
         be linked together into an executable (we should change Makefile
         architecture to support it)
        - removed testpre.prg (it requires hbpp library however this library
         cannot be linked because of duplicated symbol 'hb_strAt' defined
         in rtl library also) -the changes in source/hbpp/*.c was an attempt
         to get it working.

19990722-14:30 CET Matthew Hamilton
  * tests/working/inifiles.prg
    cFile -> @cFile in fRead statement


19990722-03:30 GMT+2 Ryszard Glab <rglab@imid.med.pl>

    *source/rtl/classes.c
    *source/rtl/console.c
    *source/rtl/errorapi.c
    *source/rtl/itemapi.c
    *source/rtl/transfrm.c
        * changed GetDynSym to hb_GetDynSym
        * changed FindDynSym to hb_FindDynSym

    *source/runner/runner.c
        * changed FindDynSym to hb_FindDynSym

    *source/vm/dynsym.c
        * changed GetDynSym to hb_GetDynSym
        * changed NewDynSym to hb_NewDynSym
        * changed FindDynSym to hb_FindDynSym
        + added initialization of hMemvar and hArea

    *source/vm/hvm.c
        * changed GetDynSym to hb_GetDynSym
        * changed NewDynSym to hb_NewDynSym
        * changed FindDynSym to hb_FindDynSym
        + added support for PUBLIC and PRIVATE variables and PARAMETERS
          (not finished yet)

    *include/extend.h
        * changed definition of DYNSYM
        + added definition of VS_MEMVAR, VS_PUBLIC, VS_PRIVATE

    *include/init.h
        + added again 'static' declaration (only for WATCOM compiler
          at this moment)

    *config/dos/watcom.cf
        * changed to not link and lib in no case exact mode

    *include/pcode.h
        - removed unused opcode HB_P_DEFSTATIC
        + added HB_P_PARAMETER to create memvar variables that store
         function/procedure parameters

    *source/rtl/codebloc.c
        *updated to support current memvars implementation

    *source/rtl/memvars.c
        + added support for PUBLIC and PRIVATE statements
        + new __PUBLIC and __PRIVATE functions that can be accessed
          from PRG code to create memvar variables
        + support for PARAMETERS statement

        NOTE: It is still in development! There is something wrong with
        reference counting (see tests/working/memvar.prg)

    *source/compiler/harbour.y
        + added support for PUBLIC and PRIVATE variables
        + added support for PARAMETERS statement

    *source/compiler/harbour.l
        + added full support for PUBLIC, PRIVATE and PARAMETERS
        * LOCAL can now be used in abbreviated form

    +tests/working/memvar.prg
        + tests memvar variables
         (NOTE: it can show unreleased memory blocks)

    *tests/working/Makefile
        + added memvar.prg

Wed Jul 21 17:39:35 1999  Gonzalo A. Diethelm  <Gonzalo.Diethelm@jda.cl>

        * include/hbsetup.h:
        Added Win32 as a case when CR/LF must be output for a new line to
        appear on the screen.

19990721-22:36 CET Patrick Mast <harbour@PatrickMast.com>
  * Makefile.vc errorsys compiles with /iinclude now

19990721-10:25 CET Eddie Runia
  * source/hbpp/hbpp.c
    Old lookup returned for '??'. Follow (ER) for the change

Wed Jul 21 15:36:04 1999  Gonzalo A. Diethelm  <Gonzalo.Diethelm@jda.cl>

        * source/compiler/harbour.y:
        Moved printing the "build..." message after the command line
        arguments have been checked, so that if the user specifies -q, it
        is not shown.

        * source/vm/hvm.c:
        Got rid of a couple of warnings.

        * include/Makefile:
        * tests/working/Makefile:
        Updates list of files.

        * include/init.h:
        * include/initsymb.h:
        * source/hbpp/preproc.c:
        Updated use of RCS Id keyword.

19990721-18:39 GMT+1 Paul Tucker / Bruno Cantero <bruno@issnet.net>
  * source/compiler/harbour.y
    Added support for empty arguments in functions.

19990721-15:50 CET Eddie Runia <eddie@runia.com>
  * source/rtl/classes.c; source/rtl/transfrm.c
    Clean-up of source

19990721-04:12 EDT Paul Tucker <ptucker@sympatico.ca>
  * source/rtl/gtapi.c
    * corrected color string Underline handling.
    * Much more color compatibility even for some undocumented
      behaviour.
      The only inconsistancy is for ie: ("w+/n*")  Clipper returns
      "w+*/n" - Harbour returns "w+/n*" This is on purpose, as it
      agrees with the documentation instead of observed behaviour.
      AFAIK, the only thing that may need change is for mono monitors.
      Is anyone using one?

19990721-09:30 CET Eddie Runia <eddie@runia>
  * source/vm/hvm.c
    Copy & Paste error

19990721-09:00 CET Jose Lalin
  * source/vm/hvm.c
    + added support for concatenation operator "-"
    + added support to generate correct runtime errors in functions:
    And(), Equal(), Greater(), GreaterEqual(),
    Inc(), Instring(), Less(), LessEqual(), Not(),
    NotEqual(), Minus(), Or(), Plus(), HB_LEN()
  + tests/working/strsub.prg
    tests for operator "-" on strings

19990721-09:00 CET Matthew Hamilton
  * tests/working/inifiles.prg
    * Case sensitive & Speed improvement

19990720-09:38 Alexander Kresin
  * source\hbpp\hbpp.c
    * Fixed bugs related to nested #ifdef, #ifndef
    * Fixed bug with '??' command

19990720-17:15 EDT David G. Holm <dholm@jsd-llc.com>
  * funclist.txt
    * Updated the status of several functions

19990720-20:55 GMT+1 Bruno Cantero <bruno@issnet.net>
  * makefile.b31
    Changed fixflex to bin\fixflex.
  * harbour.b31
    Added /iinclude to compile prg's.

19990720-20:10 CET Eddie Runia <eddie@runia.com>
  * source/vm/hvm.c
    wsize =*( (WORD *) ... part removed.

19990720-13:40 EDT Paul Tucker <ptucker@sympatico.ca>
  * source/rtl/gtapi.c
    * If a color string of ("r/b,b/r" ) is used, the
      fifth param is set equal to the second. (as in clipper)

19990720-13:30 EDT Paul Tucker <ptucker@sympatico.ca>
  * source/rtl/gtapi.c
    * implimented color attribute in gtWrite and gtScroll.
      This is the last selected color set via gt_ColorSelect()

19990721-16:35 CET David G. Holm <dholm@jsd-llc.com>
  * source/compiler/harbour.y
    ! Correct _StdFunc entty for INKEY to allow no parameters
    - Removed _StdFunc entry for SET
    * Display build date for include/version.h instead of a season

19990721-15:10 CET Felipe Coury
  + bldodbc.bat; hbodbc.b32; source/odbc/bld32exe.bat; source/odbc/harbour.mdb;
    source/odbc/hb32.bat; source/odbc/odbc.c; source/odbc/odbc.txt;
    source/odbc/odbc32.def; source/odbc/sql.ch; source/odbc/sql.h;
    source/odbc/sqlext.h; source/odbc/sqltypes.h; source/odbc/testodbc.prg
    First version of ODBC implemented.

19990720-14:35 CET Matthew Hamilton
  * tests/working/inifiles.prg
    New version installed

19990720-09:55 CET Eddie Runia <eddie@runia.com>
  * source/rtl/files.c
    #include <errno.h> added for __BORLANDC__

19990720-09:30 CET Eddie Runia <eddie@runia.com>
  * tests/working/run_all.bat
    %1 exchanged for test_all

19990719-17:55 EDT Paul Tucker <ptucker@sympatico.ca>
  * source/rtl/gtapi.c
    - removed temp init line now that init order is fixed.
    + added call to gtDone from hb_gtExit
  * source/rtl/setcolor.c
    * removed a comma
  * tests/working tstcolor.prg
    + Added 'numeric' color example.

19990719-16:50 EDT David G. Holm <dholm@jsd-llc.com>
  * config/dos/bcc31.cf
    + Added -DHARBOUR_USE_GTAPI and -DHARBOUR_USE_DOS_GTAPI
      to the C preprocessor options
  * include/set.h
    + Added prototypes for hb_consoleInitialize() and
      hb_consoleRelease(), because console doesn't own
      an include file and these two functions were added
      to allow synchronization with hb_setInitialize() and
      hb_setRelease(), both of which are prototyped here
  * include/version.h
    * Updated build to 29, set revision to "", and set date
      to 1999, 7, 19, in anticipation of a new public release
  * source/compiler/harbour.y
    + Added #include "version.h"
    * Changed version printout to use hb_build from version.h
    * Changed version printout us use "Summer" instead of "Spring"
    * Removed newline from middle of version printout
    * Moved prinout of version ahead of command line option checks,
      so that the version is always displayed, like in Clipper
  * source/rtl/console.c
    + Added hb_consoleRelease() function that calls hb_gtExit()
    * Converted InitializeConsole() from an HB_CALL_ON_STARTUP
      function to a normal function named hb_consoleInitialize()
  * source/rtl/setcolor.c
    - Removed HARBOUR GTEXIT() function
  * source/vm/hvm.c
    + Added call to hb_consoleInitialize() immediately following call to
      hb_setInitialize and added call to hb_consoleRelease() immediately
      prior to calling hb_setRelease().
  * tests/working scroll.prg
    * Changed the introductory text message
  * tests/working/tstcolor.prg
    - Removed GTEXIT() call

19990719-16:15 EDT Paul Tucker <ptucker@sympatico.ca>
   * source/rtl/gtapi.c
     * Minor change to catch last color parameter
       that may be empty

19990719-15:55 EDT Paul Tucker <ptucker@sympatico.ca>
   * source/rtl/gtapi.c
     * Added support for 'numeric' color strings
       ie: "1/7,8/15"

19990719-19:28 GMT+2 Ryszard Glab <rglab@imid.med.pl>
    *source/compiler/harbour.y
     +added 'PushFunCall' function to push the name of function. This
      function checks if passed name is an abbreviation of reserved
      function. If the abbreviation is used then the full name is pushed.

19990719-18:33 Antonio Linares <alinares@fivetech.com>
   * source/rtl/classes.c
     * enhanced methods amount meanwhile DictRealloc() is built.
     * several defines missing.
   * source/rtl/extend.c
     * new hb_xsize() function needed for classes.c DictRealloc() implementation.

19990719-18:30 GMT+2 Ryszard Glab <rglab@imid.med.pl>
    *source/compiler/harbour.y
     -removed call for non ANSI C 'stricmp'
     *changed to support abbreviated functions' names

19990719-11:40 EDT Paul Tucker <ptucker@sympatico.ca>
    *source/rtl/gtapi.c
     * Changed call in hb_gtinit() to pass the
       literal initial color setting in case
       the GT system is initialised prior to Set
     * Skipped color params in a string now keep
       their previous value.  ie ",,,r/b"
    *source/rtl/set.c
     * corrected parameter passing in _SET_COLOR case.

19990719-10:40 EDT Paul Tucker <ptucker@sympatico.ca>
    *source/compiler/harbour.y
     * replace CheckArgs() as supplied by Jose Lalin -
       with a few minor tweaks.

19990719-16:00 GMT+2 Ryszard Glab <rglab@imid.med.pl>
    *source/rtl/msgxxx.c
     +added support for Polish national messages

    *source/rtl/natmsg/msgpl852.c
    *source/rtl/natmsg/msgplmaz.c
     * corrected names of months

19990719-03:10 EDT David G. Holm <dholm@jsd-llc.com>
  * config/os2/icc.cf
    + Added /Gs+ option to enable runtime stack checking
  * include/dates.h
    + Added prototype for hb_dow()
  * include/gtapi.h
    + Added prototype for hb_gtExit()
  * include/set.h
    + Added prototype for hb_setColor()
    * Changed hb_set.HB_SET_COLOR from char * to char[64]
  * source/compiler/harbour.y
    * Replaced _StdFunc table with new table supplied by Jose Lalin,
      while keeping the entry for SET that Paul Tucker had CVSed
  * source/hbpp/hbpp.c
    * Made mpatt and rpatt buffers in ParseCommand() static.
  * source/hbpp/hbppint.c
    * Allocate sBuffer in Hp_Parse() using _xgrab() (and
      release with _xfree() before exiting)
  * source/rtl/console.c
    + Added call to hb_gtInit() to InitializeConsole()
    - Removed all gt...() calls from InitializeConsole()
  * source/rtl/gtapi.c
    + Added gt...() calls that used to be in InitializeConsole()
      to hb_gtInit() and also added a call to gtInit()
    * Renamed hb_gtexit() to hb_gtExit() to match Harbour style
    * Converted three // style comments to /* style comments */
  * source/rtl/set.c
    * Simplified handling of HB_SET_COLOR by just calling hb_setColor()
    * Made changes related to hb_set.HB_SET_COLOR now being char[64]
  * source/rtl/setcolor.c
    + Added #include <set.h>
    * Replaced gt prototypes with #include <gtapi.h>
    * Changed hb_SetColor() to hb_setColor() to match Harbour style
    * Changed hb_setColor() to use hb_set.HB_SET_COLOR instead of
      allocating a buffer and requiring the caller to free the buffer
    + Added conditional logic for not using the GT API
  * source/rtl/gt/gtwin.c
    - Removed call to hb_gtInit()
  * source/tools/dates2.c
    + Added #include <dates.h>
    ! Added missing semicolon to HB_INIT_SYMBOLS_END()
    - Removed prototypes for hb_dow() and hb_dateDecode()
  * tests/working/Makefile
    - Removed strings4.prg
    + Added tstcolor.prg
  * tests/working/empty.prg
    - Removed call to empty() with no parameters, because
      it now results in a compile error
  - tests/working/string4.prg
    - Removed this test program, because Harbour now checks for
      the correct number of arguments when compiling

19990719-00:55 EDT Paul Tucker <ptucker@sympatico.ca>
  * source/rtl/set.c
    * Trap for NIL param in Set( _SET_SETCOLOR, NIL )

19990719-00:12 EDT Paul Tucker <ptucker@sympatico.ca>
  * corrected new parameter check
    added {"SET",1,3}
    also increased strncmp len param by 1 to get null byte for
    complete match.

19990718-22:25 EDT Paul Tucker <ptucker@sympatico.ca>
  * source/rtl/gtapi.c
    * corrected returned color strings so pair ordering is
      the same as Clipper

19990718-21:20 EDT Paul Tucker <ptucker@sympatico.ca>
  * source/rtl/gt/gtwin.c
    * call hb_gtinit from gtinit
  * source/rtl/gtapi.c
    * changed gtSetColorStr and gtGetColorStr to support
      clipper compatible color strings.
  * source/rtl/set.c
    * changed _SET_COLOR support to tie in to SetColor()
  * source/rtl/setcolor.c
    * cleaned up - added HB_GTEXIT till proper exit
      support is working
  + tests/working/tstcolor.prg
    test for SetColor()
  * makefile.b16
    makefile.b31
    makefile.b32
    makefile.icc
    source/rtl/makefile
    * added setcolor
  * makefile.vc
    * added setcolor
    * changed -o$(RTL_DIR) -o$(**D)
    * added missing datesx and copyfile
    * removed duplicate errorsys from harbour.lib obj list

19990718-20:45 CET Eddie Runia <eddie@runia.com>
  - source/rdd/rdd.api
    And removed again

19990718-20:35 CET Jose Lalin
  * source/compiler/harbour.y; include/hberrors.h
    Argument checking for standard functions added. Thanks to Ryszard

19990718-20:30 CET Eddie Runia <eddie@runia.com>
  + source/rdd/rdd.api
    Restore from the attic

19990718-13:06 EDT Paul Tucker <ptucker@sympatico.ca>
  + source/rtl/setcolor.c
    * my first cvs upload
    * I'll work on adding this to the various makefiles
      as well as the required support code in gtapi.c
      (not posted yet)

19990718-18:05 CET Patrick Mast <harbour@PatrickMast.com>
  * Release of Build #28
  * version.h, updated build version

19990718-17:33 CET Patrick Mast <harbour@PatrickMast.com>
  * /source/rtl/errorsys.prg
    changed #include "include\error.ch" back into #include "error.ch"
    changed makefile.b32 to compile PRG's with switch iinclude

19990718-15:44 CET Patrick Mast <harbour@PatrickMast.com>
  * /test/working/buildvc.bat For PRG -> EXE with MSVC++
  * buildvc.bat Includes MASM'ing Symbols.obj now

19990718-15:25 CET Bruno Cantero / Eddie Runia
  * source/vm/hvm.c
    PushString endian ordered not determined by compiler but by HVM

19990718-14:13 CET Patrick Mast <harbour@PatrickMast.com>
  * /source/hbpp
    latest files from Alexander. With these files Build32.bat works ok.

19990718-14:22 CET Eddie Runia <eddie@runia.com>
  * tests/working/run_all.bat
    Harbour compile added

19990718-14:00 CET Eddie Runia <eddie@runia.com>
  * build32.bat
    bldhbpp.bat called
  * makefile.b16; makefile.b31; makefile.b32; makefile.icc; makefile.vc
    dates2 included
  * makedos.env
    very strange error. msgxxx could not include natmsg/msguk.c.
    I haven't seen this error before, -Isource/rtl was added to resolve
    the problem
  * source/rtl/dates.c; source/rtl/descend.c; source/rtl/hardcr.c;
    source/rtl/mtran.c
    Copyright Jose Lalin added
  * source/rtl/msgxxx.c
    Esparanto added
  + source/rtl/natmsg/msgeo.c
    Esparanto added
  + source/tools/dates2.c
    File from Jose Lalin added.
    The following modification have been made :
    * Symbol table added
    * Bug as reported by Andi resolved
    * Casts added to eliminate warnings produced by DJGPP
  * source/tools/makefile
    dates2.c added
  * include/initsymb.h; source/runner/runner.c; source/vm/initsymb.c
    Dates2 added to file list.
  + tests/working/dates4.prg
    Test program tools/dates2 added
  + tests/working/run_all.bat
    Batch file for testbench added. Will run test_all.prg and subsequently
    run all symbols

19990716-20:00 EDT David G. Holm <dholm@jsd-llc.com>
  * config/rules.cf
    + Added ifeq section for BCC, which requires that the output
      file be listed ahead of the input file on the command line
      (at least for version 3.1)
  + config/dos/bcc31.cf
    + New GNU Make System module for Borland C++ 3.1
      (adapted from original config/win32/bcc32.cf)
  * config/dos/global.cf
    + Added 'if not exist' to both 'dirbase::' commands
    + Added 'if exist' to all deletes of a single file type
  * config/win32/bcc32.cf
    * Applied several changes from config/dos/bcc31.cf,
      but remains untested
  * doc/gmake.txt
    + Added dos/bcc31
  * source/hbpp/hbpp.c
    ! Temporary fix to avoid an incorrect "Cycled #define" error
  * source/hbpp/hbppint.c
    ! Use of exit() warrants inclusion of stdlib.h for all compilers
  * source/rtl/environ.c
    + Added RUN() support for MSC, IBMCPP, and GCC for OS/2
  * tests/working/dosshell.prg
    + Added support for OS/2
  * tests/working/procline.prg
    - Removed unneeded 'local a' that I accidentally left in earlier

Fri Jul 16 17:53:35 1999  Gonzalo A. Diethelm  <Gonzalo.Diethelm@jda.cl>

        * source/rtl/gt/gtwin.c:
        Added the possibility to log everything to a file; this made it
        possible for me to find out what was wrong with GTwin (which is,
        noone was calling gtInit()).

        * source/rtl/console.c:
        Call gtInit() as the first console initialization. This finally
        made it possible to have a working GT on Win32 with gcc (it should
        work with other compilers too).

19990716-20:43 Alexander Kresin
  * source\hbpp\hbpp.c
    * Problem with C++ Builder resolved

19990716-18:10 CET Eddie Runia <eddie@runia.com>
  + tests/working/clasname.prg
    Test program for clasname implemented. Warning : Just a partial
    implementation
  * source/vm/hvm.c
    void Do() changed so all types call GetMethod
  * source/rtl/classes.c
    Small changes so messages to non-objects are properly handled.

19990716-16:00 CET Eddie Runia <eddie@runia.com>
  * source/rtl/transfrm.c
    Memory allocation error resolved

19990716-15:00 CET Eddie Runia <eddie@runia.com>
  * source/rtl/math.c
    Round() : One byte more should be allocated
  * source/rtl/copyfile.c; source/runner/runner.c; source/vm/initsymb.c;
    include/initsymb.h
    __CopyFile added as symbol
  * source/rtl/console.c
    DevOutPict() added as symbol

19990716-14:30 CET Eddie Runia <eddie@runia.com>
  * source/runner/runner.c
    Typo corrected

19990716-13:00 CET Eddie Runia <eddie@runia.com>
  * include/initsymb.h; source/vm/initsymb.c; source/runner/runner.c;
    include/run_exp.h
    The runner is back on-line :-))

19990716-10:54 Alexander Kresin
  * source\hbpp\hbpp.c
  * source\hbpp\table.c
    * fixed some bugs, simplified expressions in SearnRep()

19990716-06:45 GMT+1 Ryszard Glab <rglab@imid.med.pl>

        *source/compiler/harbour.y
         * corrected generation of proper static frame for functions
           (the values of static variables defined in different modules
           are no longer overlapped)

        *tests/broken/statics1.prg
        *tests/broken/statics2.prg
         -moved to tests/working directory

        *config/dos/watcom.cf
         * corrected to support HB_*_COMPILE variables

        *config/global.cf
        *config/rules.cf
         * removed duplicated definition of HB variable
         * HB_*_COMPILE variables are defined now before architecture
           and compiler specific config file is included (it allows to change
           these variables for specific architecture/compiler requirements)

        *doc/codebloc.txt
         + added description of an incompatibility with Clipper

19990715-23:40 CET Eddie Runia <eddie@runia.com>
   * tests/working/arrays.prg;
     tests/working/dosshell.prg;
     tests/working/dupvars.prg;
     tests/working/keywords.prg;
     tests/working/linecont.prg;
     tests/working/linecont.prg;
     tests/working/longstr2.prg;
     tests/working/spawn.prg;
     tests/working/spawn2.prg;
     tests/working/test10.prg;
     tests/working/testid.prg;
     tests/working/test_all.prg
     //NOTEST should be the first line

19990715-23:14 CET Patrick Mast <harbour@PatrickMast.com>
   All files for the Preprocessor lib from Felipe Coury <fcoury@flexsys-ci.com>
   + source/hbpp/preproc.c
   + doc/hbpplib.txt
   + tests/working/testpre.prg
   + Hbpplib.b32
   + Bldhbpp.bat
   * changed tests/working/bld32exe.bat (to include hbpp.lib)

Thu Jul 15 17:32:29 1999  Gonzalo A. Diethelm  <Gonzalo.Diethelm@jda.cl>

        * config/rules.cf:
        Added support for a couple of environment variables for the user
        to specify additional flags for compilation. They are C_USR and
        PRG_USR. An example using bash:

          export C_USR='-DHARBOUR_USE_GTAPI -DHARBOUR_USE_WIN_GTAPI'
          make -w

        * include/hbdefs.h:
        * source/rtl/gt/gtwin.c:
        Modified these files to be able to compile gtwin.c with gcc. It
        compiles and links, but it dumps core on execution...

19990715-16:30 Ryszard Glab <rglab@imid.med.pl>

    *source/compiler/harbour.l
     * added support for
         case ::variable
         while ::variable
     * corrected line numbering in NEXT and END keywords
     * changed ';' (line continuation logic)

    *source/compiler/harbour.y
     * corrected line numbering (opcode for line number is no longer placed
       inside an expression)

    *tests/working/procline.prg
     * corrected line numbering

    *config/linux/gcc.cf
    *config/linux/global.cf
     * corrected to support the latest changes in GNU make system

19990715-09:50 CET Patrick Mast <harbour@PatrickMast.com>
   *makefile.vc
    * Changed output for PRG's that needed to be compiled with Harbour
    * Deleted 'Classes.Prg' lines. (No need for them)
    * Added parameter -n for compiling asort.prg
    * Added parameter -n for compiling errorsys.prg
    * Deleted 'GenObj.c' lines (No need for them)
    * Changed 'Stringp.c' line $(RTL_DIR) should be $(TOOLS_DIR)
    = Works fine with MSVC++ 6.01 now

19990715-09:50 CET Patrick Mast <harbour@PatrickMast.com>
   *source/rtl/environ.c
    changed all 'defined(__MSC__)' to 'defined(__MSC__) || defined(_MSC_VER)'
    It compiles with MSVC++ 6.01 now

19990714-22:45 EDT David G. Holm <dholm@jsd-llc.com>
  * config/dos/djgpp.cf
    * Modified to support new HB_*_COMPILE variables
  * config/dos/global.cf
    - Removed initialization of old HB_*_DIR variables
  * config/dos/watcom.cf
    * Modified to support new HB_*_COMPILE variables
  + config/os2/dir.cf
    + New GNU Make System module for OS/2
  + config/os2/gcc.cf
    + New GNU Make System module for GCC for OS/2
  + config/os2/global.cf
    + New GNU Make System module for OS/2
  + config/os2/icc.cf
    + New GNU Make System module for IBM Visual Age C++ for OS/2
  + config/os2/install.cf
    + New GNU Make System module for OS/2
  * doc/gmake.txt
    + Added documentation for os2/gcc and os2/icc
    * Changed names of installation variables to HB_*_INSTALL
    * Changed NOTES section to reflect new 2-step process for a clean build
  * include/hbsetup.h
    + Added documentation of new #define for HARBOUR_GCC_OS2, which is used
      by config/os2/gcc.cf in order to ensure that the GCC build of Harbour
      for OS/2 gets created as OS_DOS_COMPATIBLE and not OS_UNIX_COMPATIBLE
    + Added platform #defines for the GT API for use by the GNU Make System
  * include/set.h
    - Removed obsolete global variable hb_set_fixed and declaration for
      obsolete HB_SETFIXED()
  * source/compiler/harbour.y
    + Added #ifdef guard for GCC around generated #pragma startup directive
      (like the #ifdef guard that was added to the runtime source modules)
    ! Display entire command line option when reporting invalid options
      (like Clipper, instead of leaving off the option switch character)
  * source/hbpp/hbpp.c
    + Added grouping parentheses as a safeguard around the one use of the
    isname() macro parameter that didn't already have a grouping
    ! The use of 'exit(1);' requires that stdlib be included for all compilers
  * source/hbpp/table.c
    ! Changed all _SET_<name> constants to match Harbour instead of Clipper
  * source/rtl/Makefile
    + Added new gtxxx.c module
  * source/rtl/environ.c
    + Added OS() support for GCC when using OS/2, because OS/2 uses 'version'
      as the version indicator and uses 'release' as a revision indicator
  * source/rtl/files.c
    + Only use S_IRUSR and S_IWUSR flags when creating a read/write file,
      per correction supplied by Dave Pearson
  + source/rtl/gtxxx.c
    + Added new module to allow the GNU Make system to build the GT API
  * source/rtl/set.c
    + Added #include <sys/types.h> for GCC, per warning generated by GCC for
      OS/2 when sys/types.h was not included
    - Removed obsolete global variable hb_set_fixed
  * source/rtl/strings.c
    ! Replaced use of obsolete hb_set_fixed with hb_set.HB_SET_FIXED
  * tests/working/codebloc.prg
    ! Corrected the spelling of 'Trying'
  * tests/working/procline.prg
    ! Corrected the expected ProcLine() line numbers
  * tests/working/testcgi.prg
    ! Initialize cRes variable to "" to get rid of run time error on line 280

Wed Jul 14 20:02:55 1999  Gonzalo A. Diethelm  <Gonzalo.Diethelm@jda.cl>

        * config/bin.cf:
        * config/c.cf:
        * config/global.cf:
        * config/header.cf:
        * config/lib.cf:
        * config/rules.cf:
        * config/win32/bcc32.cf:
        * config/win32/gcc.cf:
        * config/win32/icc.cf:
        * config/win32/msvc.cf:
        Now there are two sets of variables to control compilation and
        installation: HB_*_COMPILE points to where to get all the files
        (binaries, includes, etc.); if not defined, it will pick them off
        the working repository. HB_*_INSTALL points to where you want to
        install the files (binaries, includes, etc.) when you issue a
        "make install".

Wed Jul 14 18:20:24 1999  Gonzalo A. Diethelm  <Gonzalo.Diethelm@jda.cl>

        * config/global.cf:
        * config/rules.cf:
        * config/dos/djgpp.cf:
        * config/linux/gcc.cf:
        * config/win32/gcc.cf:
        * config/win32/msvc.cf:
        Now it is not necessary to "install" harbour anywhere.
        If you do NOT define HB_BIN_DIR, HB_INC_DIR and HB_LIB_DIR, it
        uses all the files (binaries, headers, libraries, etc.) right off
        the working repository.

        * include/Makefile:
        Updated list of files.

19990714-12:01 Alexander Kresin
  * source\hbpp\hbpp.c
  * source\hbpp\hbppint.c
  * source\hbpp\hbppmain.c
  * include\hberrors.h
    * fixed some bugs, including those, needed for classes.ch

19990713-22:30 CET Eddie Runia <eddie@runia.com>
   - source/runner/run_exp.h
   + include/run_exp.h
     run_exp.h moved because of problem with BC 4.5

19990713-20:35 CET Eddie Runia <eddie@runia.com>
   * source/rtl/tclass.prg
     Changed standard message Super to __Super
   * tests/working/clsdata.prg
     Named class name used instead of Super


Tue Jul 13 14:06:03 1999  Gonzalo A. Diethelm  <Gonzalo.Diethelm@jda.cl>

        * include/classes.ch:
        * include/compat.h:
        * include/extra.h:
        * include/super.h:
        * source/rtl/natmsg/msgbas.c:
        * source/runner/run_exp.h:
        * source/runner/runner.c:
        * tests/broken/clasname.prg:
        * tests/broken/parexpr.prg:
        * tests/broken/statics1.prg:
        * tests/broken/statics2.prg:
        * tests/broken/vec1.prg:
        * tests/working/ainstest.prg:
        * tests/working/and_or.prg:
        * tests/working/array16.prg:
        * tests/working/arrayidx.prg:
        * tests/working/arrays.prg:
        * tests/working/arrindex.prg:
        * tests/working/atest.prg:
        * tests/working/box.prg:
        * tests/working/byref.prg:
        * tests/working/calling.prg:
        * tests/working/cdow.prg:
        * tests/working/clasinit.prg:
        * tests/working/classch.prg:
        * tests/working/classes.prg:
        * tests/working/clsdata.prg:
        * tests/working/cmphello.prg:
        * tests/working/codebl.prg:
        * tests/working/codebloc.prg:
        * tests/working/comments.prg:
        * tests/working/copyfile.prg:
        * tests/working/dates.prg:
        * tests/working/dates2.prg:
        * tests/working/dates3.prg:
        * tests/working/debugtst.prg:
        * tests/working/descend.prg:
        * tests/working/dirtest.prg:
        * tests/working/docase.prg:
        * tests/working/dosshell.prg:
        * tests/working/dupvars.prg:
        * tests/working/dynobj.prg:
        * tests/working/empty.prg:
        * tests/working/exittest.prg:
        * tests/working/extend1.prg:
        * tests/working/extend2.c:
        * tests/working/fib.prg:
        * tests/working/fileio.prg:
        * tests/working/filexist.prg:
        * tests/working/fornext.prg:
        * tests/working/fornext2.prg:
        * tests/working/funcarr.prg:
        * tests/working/guess.prg:
        * tests/working/hardcr.prg:
        * tests/working/hello.prg:
        * tests/working/ifelse.prg:
        * tests/working/ifinline.prg:
        * tests/working/inherit.prg:
        * tests/working/inifiles.prg:
        * tests/working/initexit.prg:
        * tests/working/inline.prg:
        * tests/working/instr.prg:
        * tests/working/iotest.prg:
        * tests/working/iotest2.prg:
        * tests/working/keywords.prg:
        * tests/working/linecont.prg:
        * tests/working/longstr.prg:
        * tests/working/longstr2.prg:
        * tests/working/mankala.prg:
        * tests/working/mathtest.prg:
        * tests/working/mtran.prg:
        * tests/working/multiarg.prg:
        * tests/working/nums.prg:
        * tests/working/objarr.prg:
        * tests/working/objasign.prg:
        * tests/working/objects.prg:
        * tests/working/operat.prg:
        * tests/working/os.prg:
        * tests/working/output.prg:
        * tests/working/overload.prg:
        * tests/working/passref.prg:
        * tests/working/procline.prg:
        * tests/working/procname.prg:
        * tests/working/readhrb.prg:
        * tests/working/recursiv.prg:
        * tests/working/returns.prg:
        * tests/working/round.prg:
        * tests/working/rtfclass.prg:
        * tests/working/rtl_test.prg:
        * tests/working/say.prg:
        * tests/working/scroll.prg:
        * tests/working/seconds.prg:
        * tests/working/set_num.prg:
        * tests/working/set_test.prg:
        * tests/working/spawn.prg:
        * tests/working/spawn2.prg:
        * tests/working/statfun.prg:
        * tests/working/statics.prg:
        * tests/working/strcmp.prg:
        * tests/working/strdelim.prg:
        * tests/working/strings.prg:
        * tests/working/strings2.prg:
        * tests/working/strings3.prg:
        * tests/working/strings4.prg:
        * tests/working/strip.prg:
        * tests/working/syserror.prg:
        * tests/working/t1.prg:
        * tests/working/test.prg:
        * tests/working/test10.prg:
        * tests/working/test_all.prg:
        * tests/working/testcgi.prg:
        * tests/working/testcopy.prg:
        * tests/working/testerro.prg:
        * tests/working/testfor.prg:
        * tests/working/testgt.prg:
        * tests/working/testhbf.prg:
        * tests/working/testhtml.prg:
        * tests/working/testid.prg:
        * tests/working/testinc.prg:
        * tests/working/testmem.prg:
        * tests/working/teststr.prg:
        * tests/working/testtok.prg:
        * tests/working/testvars.prg:
        * tests/working/testwarn.prg:
        * tests/working/transfrm.prg:
        * tests/working/val.prg:
        * tests/working/version.prg:
        * tests/working/while.prg:
        Added RCS Id keywords to all these files.
        Got rid of a few '//' comments in C/H files.
        Added include guards to a few H files.

Tue Jul 13 13:44:04 1999  Gonzalo A. Diethelm  <Gonzalo.Diethelm@jda.cl>

        * include/Makefile:
        * source/rtl/Makefile:
        * tests/working/Makefile:
        Updated list of files.

        * source/rtl/arrays.c:
        * source/rtl/classes.c:
        * source/rtl/console.c:
        * source/rtl/dates.c:
        * source/rtl/descend.c:
        * source/rtl/dir.c:
        * source/rtl/environ.c:
        * source/rtl/files.c:
        * source/rtl/hardcr.c:
        * source/rtl/math.c:
        * source/rtl/mtran.c:
        * source/rtl/set.c:
        * source/rtl/strings.c:
        * source/rtl/transfrm.c:
        Protected all uses of #pragma startup so they won't trigger a
        warning with gcc.

        * tests/working/inifiles.prg:
        Fixed a typo.

19990712-23:40 EDT David G. Holm <dholm@jsd-llc.com>
  * include/hbdefs.h
    ! The HB_HANDLE type was being defined in the #else section of a #ifdef
      __IBMCPP__ section instead of being defined for all compilers

19990712-19:30 EDT David G. Holm <dholm@jsd-llc.com>
  * tests/working/inifiles.prg
    ! new() no longer returns nil and now checks to see if the file was
      successfully opened or created before attempting to access it

19990712-19:15 EDT David G. Holm <dholm@jsd-llc.com>
  * source/rtl/files.c
    ! hb_fsCreate now creates files that are read-write instead of write-only
    ! hb_fsRead now returns 0 instead of 65536U after a read() error

19990712-22:00 Eddie Runia <eddie@runia.com>
  * source/rtl/classes.c
    Some more test data left in

19990712-19:10 Eddie Runia <eddie@runia.com>
  * tests/working/*.prg
    Little inconsistency corrected

19990712-16:52 Antonio Linares <alinares@fivetech.com>
  * include\classes.ch
    * Inheritance class creation command support
  * Enhanced tests\working\classch.prg classes.ch sample

19990712-15:54 Antonio Linares <alinares@fivetech.com>
  * include\classes.ch
    * Missing oClass:Create call
    * Fixed Method INLINE command
  * Added tests\working\classch.prg classes.ch sample

19990712-13:56 Antonio Linares <alinares@fivetech.com>
  * include\classes.ch
    * Added support for CONSTRUCTOR and INLINE Methods

19990712-10:52 Alexander Kresin
  * source\hbpp\hbpp.c
    * fixed some bugs of #translate implementation

19990711-21:30 Eddie Runia <eddie@runia.com>
   * source/rtl/classes.c
     Debug text removed


19990711-21:15 Eddie Runia <eddie@runia.com>
   * include/hbdefs.h; include/extend.h; source/rtl/codebloc.c;
     source/rtl/memvars.c
     HANDLE changed to HB_HANDLE

19990711-20:25 Ryszard Glab <rglab@imid.med.pl>
* include/init.h
 * all functions and variables declared in this file have to be 'static'

* source/vm/initsymb.c
 * added again #ifdef HARBOUR_STRICT_ANSI_C to call functions for
   symbols table initialization only when strict ANSI C compiler
   is used.

* include/extend.h
 + added HB_VALUE structure for storing memvars and detached locals
 + added hb_struMemvar used in HB_ITEM structure

* include/hbdefs.h
 + added IT_MEMVAR constant for values stored as memvar reference
 + added IS_MEMVAR macro

* source/vm/hvm.c
 * corrected support for detached local variables
 + added support for static variables passed by reference
 * variables passed by reference can be now chained and a reference to
   static variable can be mixed with a reference to local variable
   (this should work for memvar variables too)

* source/rtl/codebloc.c
 * corrected support for detached local variables
 + added copyright info

+ source/rtl/memvars.c
 + new file for PUBLIC and PRIVATE variables handling
   (it supports detached locals currently)

* source/rtl/classes.c
 * updated to use 'ItemUnRef()' function instead of direct stack access

* source/rtl/extend.c
 * updated to use 'ItemUnRef()' function instead of direct stack access
 * removed all if( pItem->type & IT_BYREF ) and replaced with the *only*
   correct if( IS_BYREF(pItem) )

* source/rtl/Makefile
 + added memvars.c file

- tests/working/codebl2.c
 - removed this file because its code is now in codebl.prg file

* tests/working/codebl.prg
 * added new code to test detached locals (donated by David Pearson)

* tests/working/byref.prg
 * added new code to test if Harbour handles variables passed by
   reference correctly

* tests/working/Makefile
 - removed codebl2.prg

* doc/codebloc.txt
 * updated information to reflect current implementation of codeblocks

+ config/win32/bcc32.cf
 + new file for Borland C/C++ Builder
   (This file is NOT TESTED yet)

+ config/win32/icc.cf
 + new file for IBM Visual Age C++
   (This file is NOT TESTED yet)

* makefile.b16
* makefile.b32
* makefile.icc
* makefile.vc
 + added source/rtl/memvars.c

* makedos.env
 * added '-I.' switch for compiler flags

* source/compiler/harbour.l
 - removed #include "./harboury.h" (it is now handled by makedos.env)

* source/tools/stringp.prg
 * corrected bug in line 101 (':=' should be here instead of '+='

19990710-23:15 Alexander Kresin
  * source\hbpp\hbpp.c
    * fixed some bugs - now we can use classes.ch
  Old Changelog renamed to Changelog.001
  + ChangeLog
